library hOS;

// Coded by }|-|yRoN{
//
// http://osupdate.altervista.org/
// scripter_hyron@yahoo.it
// irc://irc.azzurra.org/mircscripter

uses
  Windows,
  Messages,
  SysUtils,
  ShellApi,
  CommCtrl;

const
  Version = 'Plus Build 2';
  NUM_DOCK = 4; //change this if you want dock more windows/dialogs ((4 sides * (0..4 = 5)) = 20)
                //but remember..more docks, MORE SLOW!
  STATUSBAR_ID = 32101;
  STATUSBAR_CLASS = 'mIRC_hOS_StatusBar';

  PBM_SETMARQUEE = WM_USER + 10;
  PBS_MARQUEE = $08;
  PROGRESSBAR_TIMER = 74100;

  TTS_BALLOON = $40;
  TTM_SETTITLE = WM_USER + 32;
type
  LoadInfo = record
  mVersion: Word;
  mHwnd: hWnd;
  mKeep: Bool;
end;
  TRIVERTEX = record
  X,Y : Integer;
  Red,Green,Blue,Alpha: Word;
end;
  InfoDock = record
  Name: String;
  Handle: hWnd;
  PProc: Pointer;
  X,Y,W,H: Integer;
  BackParent: hWnd;
  BackStyle,BackExStyle: Longint;
  BackW,BackH,BackX,BackY: Integer;
end;
  InfoSide = record
  Dock: array [0..NUM_DOCK] of InfoDock;
end;
  InfoProgressBar = record
  Handle: hWnd;
  PProc: Pointer;
  HandCurs,Track,Vertical: Bool;
  MarqueeMs: Longint;
end;
  InfoTrackBar = record
  Handle: hWnd;
end;
  InfoWindow = record
  Name: String;
  Handle: hWnd;
  PProc: Pointer;
end;
  InfoButton = record
  Handle: hWnd;
  PProc: Pointer;
  pos: Integer;
  tme: Bool;
  hover: Bool;
  bitmap: Bool;
  traspbmp: Cardinal;
  normbmp,hoverbmp,pressbmp,graybmp: hBitmap;
  normicon,hovericon: Integer;
  Facegrad1,Facegrad2,Text,Graytext,Light3d,Darkshadow,Highlight,Shadow: Cardinal;
  bVertical,bFacegrad1,bFacegrad2,bText,bGraytext,bLight3d,bDarkshadow,bHighlight,bShadow: Bool;
  TipHandle: hWnd;
  TipInfo: TOOLINFO;
  bTipTrack: Bool;
  TipText: String;
end;
  InfoStatusBar = record
  Handle: hWnd;
  PProc: Pointer;
  Top: Bool;
  ImageList: HIMAGELIST;
  Text: array [0..255] of String;
  ProgressBar: array [0..255] of InfoProgressBar;
  TrackBar: array [0..255] of InfoTrackBar;
  Window: array [0..255] of InfoWindow;
  Button: array [0..255] of InfoButton;
end;

var
  TitleBar: String;
  mIRCPProc: Pointer;
  mIRCHandle: hWnd;
  mIRCHmenu: hMenu;
  SwitchBarPProc: Pointer;
  mIRCHSwitchBar,mIRCHToolBar,mIRCHMDI: hWnd;
  mIRCMVOF: Pointer;
  CFM: Cardinal;
  SwitchBarPosition: Integer;
  SwitchBarInside: Bool;
  Side: array [0..3] of InfoSide;
  StatusBar: InfoStatusBar;

function mIRCWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall; forward;
function SwitchBarWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall; forward;
procedure SendData(data: string); forward;
procedure PosSwitchBar; forward;
procedure DestroyStatusBar; forward

///////////////////////////////////////////////////////////////////////////////////////////////////////

procedure LoadDll(var LI: LoadInfo); stdcall;
var
  WindowClass: tagWNDCLASSEX;
begin
  mIRCHandle := LI.mHwnd;
  CFM := CreateFileMapping(INVALID_HANDLE_VALUE,nil,PAGE_READWRITE,0,1024,'mIRC');
  mIRCMVOF := MapViewOfFile(CFM,FILE_MAP_ALL_ACCESS,0,0,0);
  mIRCHmenu := GetMenu(LI.mHwnd);
  mIRCHSwitchBar := FindWindowEx(LI.mHwnd,0,'mIRC_SwitchBar',nil);
  mIRCHToolBar := FindWindowEx(LI.mHwnd,0,'mIRC_Toolbar',nil);
  mIRCHMDI := FindWindowEx(LI.mHwnd,0,'MDIClient',nil);
  PosSwitchBar;
  mIRCPProc := Pointer(SetWindowLong(mIRCHandle,GWL_WNDPROC,Longint(@mIRCWProc)));
  SwitchBarPProc := Pointer(SetWindowLong(mIRCHSwitchBar,GWL_WNDPROC,Longint(@SwitchBarWProc)));
  WindowClass.cbSize := SizeOf(tagWNDCLASSEX);
  GetClassInfoEx(0,STATUSCLASSNAME,WindowClass);
  WindowClass.lpszClassName := STATUSBAR_CLASS;
  RegisterClassEx(WindowClass);
  LI.mKeep := true;
end;

function UnloadDll(mTimeout: Integer): Integer; stdcall;
var
  QueuePos,SidePos: Integer;
  ClassName: array [0..15] of Char;
begin
  Result := 0;
  if (mTimeout = 0) then
  begin
    if (SwitchBarPProc <> nil) then
      SetWindowLong(mIRCHSwitchBar,GWL_WNDPROC,Longint(SwitchBarPProc));
    if (mIRCPProc <> nil) then
      SetWindowLong(mIRCHandle,GWL_WNDPROC,Longint(mIRCPProc));
    for SidePos := 0 to 3 do
      for QueuePos := 0 to NUM_DOCK do
        if (IsWindow(Side[SidePos].Dock[QueuePos].Handle)) then
        begin
          if (Side[SidePos].Dock[QueuePos].PProc <> nil) then
            SetWindowLong(Side[SidePos].Dock[QueuePos].Handle,GWL_WNDPROC,Longint(Side[SidePos].Dock[QueuePos].PProc));
          GetClassName(Side[SidePos].Dock[QueuePos].Handle,ClassName,15);
          if (ClassName = 'mIRC_Custom') then
            SendData('window -c '+Side[SidePos].Dock[QueuePos].Name)
          else
            SendData('dialog -x '+Side[SidePos].Dock[QueuePos].Name);
          Side[SidePos].Dock[QueuePos].Name := '';
          Side[SidePos].Dock[QueuePos].Handle := 0;
          Side[SidePos].Dock[QueuePos].PProc := nil;
          Side[SidePos].Dock[QueuePos].X := 0;
          Side[SidePos].Dock[QueuePos].Y := 0;
          Side[SidePos].Dock[QueuePos].W := 0;
          Side[SidePos].Dock[QueuePos].H := 0;
          Side[SidePos].Dock[QueuePos].BackParent := 0;
          Side[SidePos].Dock[QueuePos].BackStyle := 0;
          Side[SidePos].Dock[QueuePos].BackExStyle := 0;
          Side[SidePos].Dock[QueuePos].BackW := 0;
          Side[SidePos].Dock[QueuePos].BackH := 0;
          Side[SidePos].Dock[QueuePos].BackX := 0;
          Side[SidePos].Dock[QueuePos].BackY := 0;
        end;
    DestroyStatusBar;
    UnregisterClass(STATUSBAR_CLASS,0);
    UnmapViewOfFile(mIRCMVOF);
    CloseHandle(CFM);
    SendMessage(mIRCHandle,WM_SIZE,0,0);
  end;
end;

function InfoDll(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
begin
  Result := 3;
  lstrcpy(data,'hOS.dll '+Version+' by }|-|yRoN{ 2004');
  MessageBox(0,'hOS.dll '+Version+' by }|-|yRoN{ 2004','hOS.dll Info:',MB_OK or MB_ICONQUESTION);
end;

////////////////////////////////////////////////////////////////////////////////

function GradientFill(DC : hDC; pVertex : Pointer; dwNumVertex : DWORD; pMesh : Pointer; dwNumMesh, dwMode: DWORD) : DWord; stdcall; external 'msimg32.dll';

function SetLayeredWindowAttributes(Hwnd: Cardinal; crKey: Cardinal; bAlpha: Byte; dwFlags: Cardinal): Boolean;
type
  TSetLayered = function(Hwnd: Cardinal; crKey: Cardinal; bAlpha: Byte; dwFlags: Cardinal): Boolean; stdcall;
var
  SetLayered: TSetLayered;
  HLayered: HINST;
begin
  Result := false;
  HLayered := LoadLibrary('user32.dll');
  if (HLayered <> 0) then
  begin
    try
      SetLayered := GetProcAddress(HLayered,'SetLayeredWindowAttributes');
      if (@SetLayered <> nil) then
       Result := SetLayered(Hwnd,crKey,bAlpha,dwFlags);
    finally
      FreeLibrary(HLayered);
    end;
  end;
end;


function IsWindowStyle(Handle: hWnd; Style: Longint): Longint;
begin
  Result := GetWindowLong(Handle,GWL_STYLE) and Style;
end;

function IsWindowStyleEx(Handle: hWnd; StyleEx: Longint): Longint;
begin
  Result := GetWindowLong(Handle,GWL_EXSTYLE) and StyleEx;
end;

procedure SetWTheme(Handle: HWND; Use: Bool);
type
  TSetTheme = function(hWnd: HWND; SubApp,SubIdList: PChar): HRESULT; stdcall;
var
  SetTheme: TSetTheme;
  HUxTheme: HINST;
begin
  HUxTheme := LoadLibrary('uxtheme.dll');
  if (HUxTheme <> 0) then
  begin
    try
      SetTheme := GetProcAddress(HUxTheme,'SetWindowTheme');
      if (@SetTheme <> nil) then
        if (Use) then
          SetTheme(Handle,nil,nil)
        else
          SetTheme(Handle,'','');
    finally
      FreeLibrary(HUxTheme);
    end;
  end;
end;

function EnumSetWTheme(Handle: hWnd; LP: Longint): Bool; stdcall;
begin
  Result := true;
  if (LP = 1) then
    SetWTheme(Handle,true)
  else
    SetWTheme(Handle,false);
end;

function GetData(data: string): pChar;
begin
  lstrcpy(mIRCMVOF,pChar(data));
  SendMessage(mIRCHandle,WM_USER + 201,1,0);
  Result := mIRCMVOF;
end;

procedure SendData(data: string);
begin
  lstrcpy(mIRCMVOF,pChar('//.'+data));
  SendMessage(mIRCHandle,WM_USER + 200,1,0);
end;

procedure Signal(data: string);
begin
  SendData('signal hOS '+data);
end;

function PopTok(var Text: String; const C: Char): String;
var
  n: Longint;
begin
  if (Text = '') then
  begin
    Result := '';
    exit;
  end;
  while (Text[1] = #32) do
    Text := Copy(Text,2,MaxInt);
  while (Text[Length(Text)] = #32) do
    Text := Copy(Text,1,Length(Text)-1);
  Result := Text;
  while (Result[1] = C) do
    Result := Copy(Result,2,MaxInt);
  while (Result[Length(Result)] = C) do
    Result := Copy(Result,1,Length(Result)-1);
  n := Pos(C,Result);
  if n = 0 then
  begin
    Text := '';
    Result := Uppercase(Result);
    while (Result[1] = #32) do
      Result := Copy(Result,2,MaxInt);
    while (Result[Length(Result)] = #32) do
      Result := Copy(Result,1,Length(Result)-1);
  end
  else
  begin
    Text := Copy(Result,n+1,Length(Result));
    Delete(Result,n,Length(Result));
    Result := Uppercase(Result);
    while (Result[1] = #32) do
      Result := Copy(Result,2,MaxInt);
    while (Result[Length(Result)] = #32) do
      Result := Copy(Result,1,Length(Result)-1);
  end;
end;

function GetTok(Source: string; const C: Char; N: Integer): string;
var SPos, Num: Integer; All: Boolean;
begin
  Result := '';
  All := (N < 0);
  if (N < 0) then
    N := N * -1;
  if (Source = '') then
    Exit;
  while (Source[1] = C) do
    Source := Copy(Source, 2, MaxInt);
  while (Source[Length(Source)] = C) do
    Source := Copy(Source, 1, Length(Source) - 1);
  Num := 1;
  SPos := Pos(C, Source);
  while (SPos > 0) do
  begin
    if (Num = N) then
    begin
      if (All) then
        Result := Copy(Source, 1, MaxInt)
      else
        Result := Copy(Source, 1, SPos - 1);
      Exit;
    end;
    Delete(Source, 1, SPos);
    Inc(Num);
    SPos := Pos(C, Source);
  end;
  if (Num = N) then
    Result := Source;
end;

function NumTok(Text: string; C: Char): Integer;
var
 C_Position,Num: Integer;
begin
  Result := 0;
  Text := trim(Text);
  if (Text = '') then
    Exit;
  while (Text[1] = C) do
    Text := Copy(Text,2,MaxInt);
  while (Text[Length(Text)] = C) do
    Text := Copy(Text,1,Length(Text)-1);
  Num := 1;
  C_Position := Pos(C,Text);
  while (C_Position > 0) do
  begin
    Delete(Text,1,C_Position);
    Inc(Num);
    C_Position := Pos(C,Text);
  end;
  Result := Num;
end;

function IsTok(Text: string; Token: string; C: Char): Boolean;
var
  C_Position: Integer;
begin
  Result := false;
  Text := Uppercase(trim(Text));
  Token := Uppercase(trim(Token));
  if ((Text = '') or (Token = '')) then
    Exit;
  while (Text[1] = C) do
    Text := Copy(Text,2,MaxInt);
  while (Text[Length(Text)] = C) do
    Text := Copy(Text,1,Length(Text)-1);
  while (Token[1] = C) do
    Token := Copy(Token,2,MaxInt);
  while (Token[Length(Token)] = C) do
    Token := Copy(Token,1,Length(Token)-1);
  C_Position := Pos(C,Text);
  while (C_Position > 0) do
  begin
    if (Token = Copy(Text,1,C_Position -1)) then
    begin
      Result := true;
      exit;
    end;
    Delete(Text,1,C_Position);
    C_Position := Pos(C,Text);
  end;
  if (Token = Copy(Text,1,MaxInt)) then
    Result := true;
end;

function CharIsIn(Text: string; const C: Char): Boolean;
var
  N: Integer;
begin
  Result := false;
  Text := trim(Text);
  if ((Text = '') or (C = '')) then
    Exit;
  N := Pos(C,Text);
  if (N > 0) then
    Result := true;
end;

function GetHwnd(Window: String): hWnd;
var
  E: Integer;
begin
  val(GetData('$window('+Window+').hwnd'),Result,E);
  if (IsWindow(Result)) then exit;
  val(GetData('$dialog('+Window+').hwnd'),Result,E);
  if (IsWindow(Result)) then exit;
  Result := 0;
end;

procedure PosSwitchBar;
var
  Key: array [0..500] of Char;
begin
  SendData('saveini');
  lstrcpy(Key,GetData('$mircini'));
  GetPrivateProfileString('options','n4','',Key,200,Key);
  SwitchBarPosition := strtoint(GetTok(Key,',',21));
end;

function GetDockPProc(Handle: hWnd): Pointer;
var
  SidePos,QueuePos: Integer;
begin
  Result := nil;
  for SidePos := 0 to 3 do
    for QueuePos := 0 to NUM_DOCK do
      if (Side[SidePos].Dock[QueuePos].Handle = Handle) then
        Result := Side[SidePos].Dock[QueuePos].PProc;
end;

function GetDockName(Handle: hWnd): String;
var
  SidePos,QueuePos: Integer;
begin
  Result := '';
  for SidePos := 0 to 3 do
    for QueuePos := 0 to NUM_DOCK do
      if (Side[SidePos].Dock[QueuePos].Handle = Handle) then
        Result := Side[SidePos].Dock[QueuePos].Name;
end;

function IsDock(Handle: hWnd): Bool;
var
  SidePos,QueuePos: Integer;
begin
  Result := false;
  for SidePos := 0 to 3 do
    for QueuePos := 0 to NUM_DOCK do
      if (Side[SidePos].Dock[QueuePos].Handle = Handle) then
        Result := true;
end;

function IsPanelStatusBar(Panel: Integer): Boolean;
begin
 Result := true;
 if ((Panel < 1) and (Panel > SendMessage(StatusBar.Handle,SB_GETPARTS,0,0))) then
   Result := false;
end;


function IsPanelUsedStatusBar(Panel: Integer): Integer;
begin
  Result := 0;
  if (IsWindow(StatusBar.ProgressBar[Panel-1].Handle)) then
    Result := 1
  else if (IsWindow(StatusBar.TrackBar[Panel-1].Handle)) then
    Result := 2
  else if (IsWindow(StatusBar.Window[Panel-1].Handle)) then
    Result := 3
  else if (IsWindow(StatusBar.Button[Panel-1].Handle)) then
    Result := 4
end;

function GetPanelFromCtrlHwnd(Handle: hWnd): Integer;
var
  n: Integer;
begin
  for n := 0 to SendMessage(StatusBar.Handle,SB_GETPARTS,0,0)-1 do
  begin
    if ((StatusBar.ProgressBar[n].Handle = Handle) or
    (StatusBar.TrackBar[n].Handle = Handle) or
    (StatusBar.Window[n].Handle = Handle) or
    (StatusBar.Button[n].Handle = Handle)) then
      break;
  end;
  Result := n;
end;

function GetPanelStatusBar(CursorPos: Longint): Integer;
var
  n: Integer;
  r: TRect;
begin
  Result := 0;
  for n := 0 to SendMessage(StatusBar.Handle,SB_GETPARTS,0,0)-1 do
  begin
    SendMessage(StatusBar.Handle,SB_GETRECT,n,lParam(@r));
    if ((LoWord(CursorPos) >= r.Left) and (LoWord(CursorPos) <= r.Right) and (HiWord(CursorPos) >= r.Top) and (HiWord(CursorPos) <= r.Bottom)) then
    begin
      Result := n+1;
      exit;
    end;
  end;
end;


procedure ResizeStatusBar;
var
  n: Integer;
  r: TRect;
begin
  for n := 0 to SendMessage(StatusBar.Handle,SB_GETPARTS,0,0)-1 do
  begin
    SendMessage(StatusBar.Handle,SB_GETRECT,n,lParam(@r));
    if (IsWindow(StatusBar.ProgressBar[n].Handle)) then
      MoveWindow(StatusBar.ProgressBar[n].Handle,r.Left,r.Top,r.Right-r.Left,r.Bottom-r.Top,true)
    else if (IsWindow(StatusBar.TrackBar[n].Handle)) then
      MoveWindow(StatusBar.TrackBar[n].Handle,r.Left,r.Top,r.Right-r.Left,r.Bottom-r.Top,true)
    else if (IsWindow(StatusBar.Window[n].Handle)) then
      MoveWindow(StatusBar.Window[n].Handle,r.Left,r.Top,r.Right-r.Left,r.Bottom-r.Top,true)
    else if (IsWindow(StatusBar.Button[n].Handle)) then
      MoveWindow(StatusBar.Button[n].Handle,r.Left,r.Top,r.Right-r.Left,r.Bottom-r.Top,true);
  end;
end;

procedure DestroyStatusBar;
var
  n: Integer;
begin
  if (IsWindow(StatusBar.Handle)) then
  begin
    for n := 0 to 255 do
    begin
      StatusBar.Text[n] := '';
      if (IsWindow(StatusBar.ProgressBar[n].Handle)) then
      begin
        if (StatusBar.ProgressBar[n].PProc <> nil) then
          SetWindowLong(StatusBar.ProgressBar[n].Handle,GWL_WNDPROC,Longint(StatusBar.ProgressBar[n].PProc));
        DestroyWindow(StatusBar.ProgressBar[n].Handle);
        StatusBar.ProgressBar[n].Handle := 0;
        StatusBar.ProgressBar[n].PProc := nil;
        StatusBar.ProgressBar[n].MarqueeMs := 100;
        StatusBar.ProgressBar[n].Track := false;
        StatusBar.ProgressBar[n].HandCurs := false;
        StatusBar.ProgressBar[n].Vertical := false;
      end
      else if (IsWindow(StatusBar.TrackBar[n].Handle)) then
      begin
        DestroyWindow(StatusBar.TrackBar[n].Handle);
        StatusBar.TrackBar[n].Handle := 0;
      end
      else if (IsWindow(StatusBar.Window[n].Handle)) then
      begin
        if (StatusBar.Window[n].PProc <> nil) then
          SetWindowLong(StatusBar.Window[n].Handle,GWL_WNDPROC,Longint(StatusBar.Window[n].PProc));
        SendData('window -c '+StatusBar.Window[n].Name);
        StatusBar.Window[n].Name := '';
        StatusBar.Window[n].Handle := 0;
        StatusBar.Window[n].PProc := nil;
      end
      else if (IsWindow(StatusBar.Button[n].Handle)) then
      begin
        if (StatusBar.Button[n].PProc <> nil) then
          SetWindowLong(StatusBar.Button[n].Handle,GWL_WNDPROC,Longint(StatusBar.Button[n].PProc));
        DestroyWindow(StatusBar.Button[n].Handle);
        StatusBar.Button[n].Handle := 0;
        StatusBar.Button[n].PProc := nil;
        StatusBar.Button[n].pos := 0;
        StatusBar.Button[n].tme := false;
        StatusBar.Button[n].hover := false;
        StatusBar.Button[n].bitmap := false;
        StatusBar.Button[n].traspbmp := 0;
        DeleteObject(StatusBar.Button[n].normbmp);
        DeleteObject(StatusBar.Button[n].hoverbmp);
        DeleteObject(StatusBar.Button[n].pressbmp);
        DeleteObject(StatusBar.Button[n].graybmp);
        StatusBar.Button[n].normicon := 0;
        StatusBar.Button[n].hovericon := 0;
        StatusBar.Button[n].bVertical := false;
        StatusBar.Button[n].Facegrad1 := 0;
        StatusBar.Button[n].bFacegrad1 := false;
        StatusBar.Button[n].Facegrad2 := 0;
        StatusBar.Button[n].bFacegrad2 := false;
        StatusBar.Button[n].Text := 0;
        StatusBar.Button[n].bText := false;
        StatusBar.Button[n].Graytext := 0;
        StatusBar.Button[n].bGraytext := false;
        StatusBar.Button[n].Light3d := 0;
        StatusBar.Button[n].bLight3d := false;
        StatusBar.Button[n].Darkshadow := 0;
        StatusBar.Button[n].bDarkshadow := false;
        StatusBar.Button[n].Highlight := 0;
        StatusBar.Button[n].bHighlight := false;
        StatusBar.Button[n].Shadow := 0;
        StatusBar.Button[n].bShadow := false;
        SendMessage(StatusBar.Button[n].TipHandle,TTM_DELTOOL,0,lParam(@StatusBar.Button[n].TipInfo));
        DestroyWindow(StatusBar.Button[n].TipHandle);
        StatusBar.Button[n].TipHandle := 0;
        StatusBar.Button[n].TipText := '';
        StatusBar.Button[n].bTipTrack := false;
      end;
    end;
    if (StatusBar.PProc <> nil) then
      SetWindowLong(StatusBar.Handle,GWL_WNDPROC,Longint(StatusBar.PProc));
    DestroyWindow(StatusBar.Handle);
    ImageList_Destroy(StatusBar.ImageList);
    StatusBar.Handle := 0;
    StatusBar.PProc := nil;
    StatusBar.Top := false;
  end;
end;

procedure PaintText(DC: hDC; var Text: string; Color,ShadowColor: Cardinal; Shadow: Boolean; var r: TRect; Font: tagLOGFONT);
var
 RectShadow: TRect;
 tmpSize: TSize;
 FontHandle: hFont;
begin
  FontHandle := SelectObject(DC,CreateFontIndirect(Font));
  SetBkMode(DC,TRANSPARENT);
  if (Shadow) then
  begin
    SetTextColor(DC,ShadowColor);
    SetRect(RectShadow,r.Left + 1,r.Top + 2,r.Right,r.Bottom);
    DrawText(DC,pChar(Text),-1,RectShadow,DT_LEFT or DT_VCENTER or DT_SINGLELINE or DT_NOPREFIX);
  end;
  SetTextColor(DC,Color);
  DrawText(DC,pChar(Text),-1,r,DT_LEFT or DT_VCENTER or DT_SINGLELINE or DT_NOPREFIX);
  GetTextExtentPoint32(DC,pChar(Text),Length(Text),tmpSize);
  inc(r.Left,tmpSize.cx);
  DeleteObject(SelectObject(DC,FontHandle));
  Text := '';
end;

function IsNum(C: Char): Boolean;
begin
  result := false;
  if ((C >= '0') and (C <= '9')) then
    result := true;
end;

procedure FormatText(DC: hDC; Text: pChar; r: TRect);
var
  n: Integer;
  Output,tmp: String;
  Color,ShadowColor: Cardinal;
  Shadow: Boolean;
  Font: tagLOGFONT;
begin
  n := 0;
  Color := GetSysColor(COLOR_MENUTEXT);
  ShadowColor := 0;
  Shadow := false;
  Output := '';
  GetObject(SendMessage(StatusBar.Handle,WM_GETFONT,0,0),SizeOf(Font),@Font);
  Font.lfWeight := 0;
  Font.lfItalic := 0;
  Font.lfUnderline := 0;
  Font.lfStrikeOut := 0;
  while (Text[n] <> '') do
  begin
    if (Text[n] = #1) then //RGB COLOR 0->16777215
    begin
      PaintText(DC,Output,Color,ShadowColor,Shadow,r,Font);
      tmp := '';
      while (IsNum(Text[n+1])) do
      begin
        inc(n);
        tmp := tmp+Text[n];
      end;
      if (tmp = '') then
        Color := GetSysColor(COLOR_MENUTEXT)
      else
        Color := strtoint(tmp);
      tmp := '';
      if (Text[n+1] = ',') then
      begin
        if (IsNum(Text[n+2])) then
        begin
          inc(n);
          while (IsNum(Text[n+1])) do
          begin
            inc(n);
            tmp := tmp+Text[n];
          end;
          ShadowColor := strtoint(tmp);
          Shadow := true;
        end;
      end
      else
        Shadow := false;
      if (Text[n+1] = #1) then
        inc(n);
    end
    else if (Text[n] = #3) then // MIRC COLOR 0->15
    begin
      PaintText(DC,Output,Color,ShadowColor,Shadow,r,Font);
      if (IsNum(Text[n+1])) then
      begin
        inc(n);
        tmp := Text[n];
        if (IsNum(Text[n+1])) then
        begin
          inc(n);
          tmp := tmp+Text[n];
        end;
        Color := strtoint(GetData('$color('+tmp+')'));
      end
      else
      begin
        Color := GetSysColor(COLOR_MENUTEXT);
        Shadow := false;
      end;
      if (Text[n+1] = ',') then
      begin
        if (IsNum(Text[n+2])) then
        begin
          inc(n,2);
          tmp := Text[n];
          if (IsNum(Text[n+1])) then
          begin
            inc(n);
            tmp := tmp+Text[n];
          end;
          ShadowColor := strtoint(GetData('$color('+tmp+')'));
          Shadow := true;
        end
        else
          Shadow := false;
      end;
    end
    else if (Text[n] = #2) then  //BOLD
    begin
      PaintText(DC,Output,Color,ShadowColor,Shadow,r,Font);
      if (Font.lfWeight = 700) then
        Font.lfWeight := 0
      else
        Font.lfWeight := 700;
    end
    else if (Text[n] = #31) then  //UNDERLINE
    begin
      PaintText(DC,Output,Color,ShadowColor,Shadow,r,Font);
      if (Font.lfUnderline = 1) then
        Font.lfUnderline := 0
      else
        Font.lfUnderline := 1;
    end
    else if (Text[n] = #22) then  //STRIKEOUT
    begin
      PaintText(DC,Output,Color,ShadowColor,Shadow,r,Font);
      if (Font.lfStrikeOut = 1) then
        Font.lfStrikeOut := 0
      else
        Font.lfStrikeOut := 1;
    end
    else if (Text[n] = #15) then  //ITALIC
    begin
      PaintText(DC,Output,Color,ShadowColor,Shadow,r,Font);
      if (Font.lfItalic = 1) then
        Font.lfItalic := 0
      else
        Font.lfItalic := 1;
    end
    else
      Output := Output+Text[n];
    inc(n);
  end;
  PaintText(DC,Output,Color,ShadowColor,Shadow,r,Font);
end;

procedure Button_Pressed(DrawStruct: DRAWITEMSTRUCT; Panel: Integer);
var
  Brush: hBrush;
  Bmp: Bitmap;
  r: TRect;
  DC: hDC;
  buffer: array [0..900] of Char;
  IconSize,Icon: Integer;
  FontSize: TSize;
  Mesh: GRADIENT_RECT;
  tt: array [0..1] of TRIVERTEX;
  nRGB: Cardinal;
begin
  GetWindowText(DrawStruct.hwndItem,buffer,900);
  DC := DrawStruct.hDC;
  SetBKMode(DC,TRANSPARENT);
  r := DrawStruct.rcItem;
  if (StatusBar.Button[Panel].bitmap) then
  begin
    DC := CreateCompatibleDC(DrawStruct.hDC);
    GetObject(StatusBar.Button[Panel].pressbmp,SizeOf(Bitmap),@Bmp);
    SelectObject(DC,StatusBar.Button[Panel].pressbmp);
    TransparentBlt(DrawStruct.hDC,r.Left,r.Top,r.Right-r.Left,r.Bottom-r.Top,DC,0,0,Bmp.bmWidth,Bmp.bmHeight,StatusBar.Button[Panel].traspbmp);
    DeleteDC(DC);
  end
  else
  begin
  //draw face
  tt[0].x := r.Left;
  tt[0].y := r.Top;
  tt[1].x := r.Right;
  tt[1].y := r.Bottom;
  if (StatusBar.Button[Panel].bFacegrad1) then
    nRGB := StatusBar.Button[Panel].Facegrad1
  else
    nRGB := GetSysColor(COLOR_BTNFACE);
  tt[0].Red := StrToInt('$'+IntToHex(GetRValue(nRGB),0)+'00');
  tt[0].Green := StrToInt('$'+IntToHex(GetGValue(nRGB),0)+'00');
  tt[0].Blue := StrToInt('$'+IntToHex(GetBValue(nRGB),0)+'00');
  tt[0].Alpha := $0000;
  if (StatusBar.Button[Panel].bFacegrad2) then
    nRGB := StatusBar.Button[Panel].Facegrad2
  else
    nRGB := GetSysColor(COLOR_BTNFACE);
  tt[1].Red := StrToInt('$'+IntToHex(GetRValue(nRGB),0)+'00');
  tt[1].Green := StrToInt('$'+IntToHex(GetGValue(nRGB),0)+'00');
  tt[1].Blue := StrToInt('$'+IntToHex(GetBValue(nRGB),0)+'00');
  tt[1].Alpha := $0000;
  Mesh.UpperLeft := 1;
  Mesh.LowerRight := 0;
  if (StatusBar.Button[Panel].bVertical) then
    GradientFill(DC,@tt,2,@Mesh,1,GRADIENT_FILL_RECT_V)
  else
    GradientFill(DC,@tt,2,@Mesh,1,GRADIENT_FILL_RECT_H);
  //draw icon
  SetRect(r,DrawStruct.rcItem.Left+5,DrawStruct.rcItem.Top+2,DrawStruct.rcItem.Right-1,DrawStruct.rcItem.Bottom-1);
  if (StatusBar.Button[Panel].hover) then
    Icon := StatusBar.Button[Panel].hovericon
  else
    Icon := StatusBar.Button[Panel].normicon;
  if (StatusBar.Button[Panel].pos = 2) then
  begin
    if (Icon <> 0) then
      ImageList_GetIconSize(StatusBar.ImageList,IconSize,IconSize);
    GetTextExtentPoint32(DC,@buffer,Length(pChar(@buffer)),FontSize);
    r.Left := (r.Left + r.Right) div 2 - FontSize.cx div 2 - IconSize div 2 - 2;
  end
  else if (StatusBar.Button[Panel].pos = 1) then
  begin
    if (Icon <> 0) then
      ImageList_GetIconSize(StatusBar.ImageList,IconSize,IconSize);
    GetTextExtentPoint32(DC,@buffer,Length(pChar(@buffer)),FontSize);
    r.Left := r.Right - FontSize.cx - IconSize - 4;
  end;
  if (Icon <> 0) then
  begin
    ImageList_GetIconSize(StatusBar.ImageList,IconSize,IconSize);
    ImageList_DrawEx(StatusBar.ImageList,Icon-1,DC,r.Left,(r.Bottom + r.Top) div 2 - IconSize div 2 + 1,IconSize,IconSize,CLR_NONE,CLR_NONE,ILD_TRANSPARENT);
    inc(r.Left,IconSize+3);
  end;
  //draw text
  if (StatusBar.Button[Panel].bText) then
    SetTextColor(DC,StatusBar.Button[Panel].Text)
  else
    SetTextColor(DC,GetSysColor(COLOR_BTNTEXT));
  DrawText(DC,@buffer,-1,r,DT_LEFT or DT_NOPREFIX or DT_VCENTER or DT_SINGLELINE or DT_WORDBREAK);
  r := DrawStruct.rcItem;
  //flat frame
  if (IsWindowStyle(DrawStruct.hwndItem,BS_FLAT) > 0) then
  begin
    Brush := CreateSolidBrush(0);
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
    SetRect(r,r.Left+1,r.Top+1,r.Right-1,r.Bottom-1);
    if (StatusBar.Button[Panel].bHighlight) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Highlight)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_BTNHIGHLIGHT));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
  end
  else   //normal frame
  begin
    SetRect(r,r.Left+1,r.Top+1,r.Right,r.Bottom);
    if (StatusBar.Button[Panel].bShadow) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Shadow)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_BTNSHADOW));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
    SetRect(r,r.Left-1,r.Top-1,r.Right-1,r.Bottom-1);
    if (StatusBar.Button[Panel].bLight3d) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Light3d)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_3DLIGHT));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
    SetRect(r,r.Left,r.Top,r.Right+1,r.Bottom+1);
    if (StatusBar.Button[Panel].bDarkshadow) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Darkshadow)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_3DDKSHADOW));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
    SetRect(r,r.Left-1,r.Top-1,r.Right,r.Bottom);
    if (StatusBar.Button[Panel].bHighlight) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Highlight)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_BTNHIGHLIGHT));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
  end;
//  SetRect(r,r.Left+4,r.Top+4,r.Right-3,r.Bottom-3);
//  if ((DrawStruct.itemState and ODS_FOCUS) > 0) then
//    DrawFocusRect(DC,r);
  end;
end;

procedure Button_Unpressed(DrawStruct: DRAWITEMSTRUCT; Panel: Integer);
var
  Brush: hBrush;
  hBmp: hBitmap;
  Bmp: Bitmap;
  r: TRect;
  DC: hDC;
  buffer: array [0..900] of Char;
  IconSize,Icon: Integer;
  FontSize: TSize;
  Mesh: GRADIENT_RECT;
  tt: array [0..1] of TRIVERTEX;
  nRGB: Cardinal;
begin
  GetWindowText(DrawStruct.hwndItem,buffer,900);
  DC := DrawStruct.hDC;
  SetBKMode(DC,TRANSPARENT);
  r := DrawStruct.rcItem;
  if (StatusBar.Button[Panel].bitmap) then
  begin
    DC := CreateCompatibleDC(DrawStruct.hDC);
    if ((DrawStruct.itemState and ODS_DISABLED) > 0) then
      hBmp := StatusBar.Button[Panel].graybmp
    else if (StatusBar.Button[Panel].hover) then
      hBmp := StatusBar.Button[Panel].hoverbmp
    else
      hBmp := StatusBar.Button[Panel].normbmp;
    GetObject(hBmp,SizeOf(Bitmap),@Bmp);
    SelectObject(DC,hBmp);
    TransparentBlt(DrawStruct.hDC,r.Left,r.Top,r.Right-r.Left,r.Bottom-r.Top,DC,0,0,Bmp.bmWidth,Bmp.bmHeight,StatusBar.Button[Panel].traspbmp);
    DeleteDC(DC);
  end
  else
  begin
  //draw face
  tt[0].x := r.Left;
  tt[0].y := r.Top;
  tt[1].x := r.Right;
  tt[1].y := r.Bottom;
  if (StatusBar.Button[Panel].bFacegrad1) then
    nRGB := StatusBar.Button[Panel].Facegrad1
  else
    nRGB := GetSysColor(COLOR_BTNFACE);
  tt[0].Red := StrToInt('$'+IntToHex(GetRValue(nRGB),0)+'00');
  tt[0].Green := StrToInt('$'+IntToHex(GetGValue(nRGB),0)+'00');
  tt[0].Blue := StrToInt('$'+IntToHex(GetBValue(nRGB),0)+'00');
  tt[0].Alpha := $0000;
  if (StatusBar.Button[Panel].bFacegrad2) then
    nRGB := StatusBar.Button[Panel].Facegrad2
  else
    nRGB := GetSysColor(COLOR_BTNFACE);
  tt[1].Red := StrToInt('$'+IntToHex(GetRValue(nRGB),0)+'00');
  tt[1].Green := StrToInt('$'+IntToHex(GetGValue(nRGB),0)+'00');
  tt[1].Blue := StrToInt('$'+IntToHex(GetBValue(nRGB),0)+'00');
  tt[1].Alpha := $0000;
  Mesh.UpperLeft := 1;
  Mesh.LowerRight := 0;
  if (StatusBar.Button[Panel].bVertical) then
    GradientFill(DC,@tt,2,@Mesh,1,GRADIENT_FILL_RECT_V)
  else
    GradientFill(DC,@tt,2,@Mesh,1,GRADIENT_FILL_RECT_H);
  //draw icon
  SetRect(r,DrawStruct.rcItem.Left+4,DrawStruct.rcItem.Top+1,DrawStruct.rcItem.Right-2,DrawStruct.rcItem.Bottom-2);
  if (StatusBar.Button[Panel].hover) then
    Icon := StatusBar.Button[Panel].hovericon
  else
    Icon := StatusBar.Button[Panel].normicon;
  if (StatusBar.Button[Panel].pos = 2) then
  begin
    if (Icon <> 0) then
      ImageList_GetIconSize(StatusBar.ImageList,IconSize,IconSize);
    GetTextExtentPoint32(DC,@buffer,Length(pChar(@buffer)),FontSize);
    r.Left := (r.Left + r.Right) div 2 - FontSize.cx div 2 - IconSize div 2 - 2;
  end
  else if (StatusBar.Button[Panel].pos = 1) then
  begin
    if (Icon <> 0) then
      ImageList_GetIconSize(StatusBar.ImageList,IconSize,IconSize);
    GetTextExtentPoint32(DC,@buffer,Length(pChar(@buffer)),FontSize);
    r.Left := r.Right - FontSize.cx - IconSize - 4;
  end;
  if (Icon <> 0) then
  begin
    ImageList_GetIconSize(StatusBar.ImageList,IconSize,IconSize);
    if ((DrawStruct.itemState and ODS_DISABLED) > 0) then
      ImageList_DrawEx(StatusBar.ImageList,Icon-1,DC,r.Left,(r.Bottom + r.Top) div 2 - IconSize div 2 + 1,IconSize,IconSize,CLR_NONE,CLR_NONE,ILD_TRANSPARENT or ILD_BLEND50)
    else
      ImageList_DrawEx(StatusBar.ImageList,Icon-1,DC,r.Left,(r.Bottom + r.Top) div 2 - IconSize div 2 + 1,IconSize,IconSize,CLR_NONE,CLR_NONE,ILD_TRANSPARENT);
    inc(r.Left,IconSize+3);
  end;
  //draw text
  if ((DrawStruct.itemState and ODS_DISABLED) > 0) then
  begin
    SetRect(r,r.Left+1,r.Top+1,r.Right,r.Bottom+1);
    if (StatusBar.Button[Panel].bHighlight) then
      SetTextColor(DC,StatusBar.Button[Panel].Highlight)
    else
      SetTextColor(DC,GetSysColor(COLOR_BTNHIGHLIGHT));
    DrawText(DC,@buffer,-1,r,DT_LEFT or DT_NOPREFIX or DT_VCENTER or DT_SINGLELINE or DT_WORDBREAK);
    SetRect(r,r.Left-1,r.Top-1,r.Right,r.Bottom-1);
    if (StatusBar.Button[Panel].bGraytext) then
      SetTextColor(DC,StatusBar.Button[Panel].Graytext)
    else
      SetTextColor(DC,GetSysColor(COLOR_GRAYTEXT));
  end
  else
  begin
    if (StatusBar.Button[Panel].bText) then
      SetTextColor(DC,StatusBar.Button[Panel].Text)
    else
      SetTextColor(DC,GetSysColor(COLOR_BTNTEXT));
  end;
  DrawText(DC,@buffer,-1,r,DT_LEFT or DT_NOPREFIX or DT_VCENTER or DT_SINGLELINE or DT_WORDBREAK);
  r := DrawStruct.rcItem;
  //flat frame
  if (IsWindowStyle(DrawStruct.hwndItem,BS_FLAT) > 0) then
  begin
    Brush := CreateSolidBrush(0);
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
    SetRect(r,r.Left+1,r.Top+1,r.Right-1,r.Bottom-1);
    if (StatusBar.Button[Panel].bHighlight) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Highlight)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_BTNHIGHLIGHT));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
  end
  else   //normal frame
  begin
    SetRect(r,r.Left+1,r.Top+1,r.Right,r.Bottom);
    if (StatusBar.Button[Panel].bLight3d) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Light3d)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_3DLIGHT));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
    SetRect(r,r.Left-1,r.Top-1,r.Right-1,r.Bottom-1);
    if (StatusBar.Button[Panel].bShadow) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Shadow)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_BTNSHADOW));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
    SetRect(r,r.Left,r.Top,r.Right+1,r.Bottom+1);
    if (StatusBar.Button[Panel].bHighlight) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Highlight)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_BTNHIGHLIGHT));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
    SetRect(r,r.Left-1,r.Top-1,r.Right,r.Bottom);
    if (StatusBar.Button[Panel].bDarkshadow) then
      Brush := CreateSolidBrush(StatusBar.Button[Panel].Darkshadow)
    else
      Brush := CreateSolidBrush(GetSysColor(COLOR_3DDKSHADOW));
    FrameRect(DC,r,Brush);
    Deleteobject(Brush);
  end;
//  SetRect(r,r.Left+4,r.Top+4,r.Right-3,r.Bottom-3);
//  if ((DrawStruct.itemState and ODS_FOCUS) > 0) then
//    DrawFocusRect(DC,r);
  end;
end;

////////////////////////////////////////////////////////////////////////////////

function mIRCWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall;
var
  tmp,MDI_X,MDI_Y,MDI_W,MDI_H,

  DocksBottomH,DocksTopH,DocksLeftW,DocksRightW: Integer;

  QueuePos,SidePos: Integer;
  RmIRC,RSwitchBar,RToolBar,RStatusBar: TRect;
  DrawStruct: DRAWITEMSTRUCT;
  Icon: hIcon;
  IconSize: _ICONINFO;
begin
  case Msg of
    WM_SIZE: begin
      MDI_X := 0;
      MDI_Y := 0;
      MDI_W := 0;
      MDI_H := 0;
      GetClientRect(mIRCHandle,RmIRC);
      GetClientRect(mIRCHSwitchBar,RSwitchBar);
      GetClientRect(mIRCHToolBar,RToolBar);
      GetClientRect(StatusBar.Handle,RStatusBar);
      if (not IsWindowVisible(mIRCHToolBar)) then
        RToolBar.Bottom := 0;
      if (not IsWindowVisible(mIRCHSwitchBar)) then
      begin
        RSwitchBar.Right := 0;
        RSwitchBar.Bottom := 0;
      end;
      if (not IsWindow(StatusBar.Handle)) then
        RStatusBar.Bottom := 0;

      DocksBottomH := 0;
      DocksTopH := 0;
      DocksLeftW := 0;
      DocksRightW := 0;
      for QueuePos := 0 to NUM_DOCK do
      begin
        inc(DocksBottomH,Side[0].Dock[QueuePos].H);
        inc(DocksTopH,Side[1].Dock[QueuePos].H);
        inc(DocksLeftW,Side[2].Dock[QueuePos].W);
        inc(DocksRightW,Side[3].Dock[QueuePos].W);
      end;

      case SwitchBarPosition of
        //BOTTOM CASE
        0: begin
          //SWITCHBAR
          RSwitchBar.Left := 0;
          if (SwitchBarInside) then
            inc(RSwitchBar.Left,DocksLeftW);
          RSwitchBar.Right := RmIRC.Right;
          if (SwitchBarInside) then
          begin
            dec(RSwitchBar.Right,DocksLeftW);
            dec(RSwitchBar.Right,DocksRightW);
          end;
          RSwitchBar.Top := RmIRC.Bottom - RSwitchBar.Bottom;
          if (SwitchBarInside) then
            dec(RSwitchBar.Top,DocksBottomH);
          if (not StatusBar.Top) then
            dec(RSwitchBar.Top,RStatusBar.Bottom);
          tmp := RToolBar.Bottom + DocksTopH;
          if (not SwitchBarInside) then
            inc(tmp,DocksBottomH);
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          if (RSwitchBar.Top <= tmp) then RSwitchBar.Top := tmp;
          //BOTTOM QUEUE SIDE LIST
          for QueuePos := 0 to NUM_DOCK do
            Side[0].Dock[QueuePos].X := 0;
          tmp := RmIRC.Bottom;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Bottom);
          if (not StatusBar.Top) then
            dec(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
          begin
            dec(tmp,Side[0].Dock[QueuePos].H);
            Side[0].Dock[QueuePos].Y := tmp;
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (SwitchBarInside) then
            inc(tmp,RSwitchBar.Bottom);
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := NUM_DOCK downto 0 do
          begin
            if (Side[0].Dock[QueuePos].Y <= tmp) then
              Side[0].Dock[QueuePos].Y := tmp;
            inc(tmp,Side[0].Dock[QueuePos].H);
          end;
          for QueuePos := 0 to NUM_DOCK do
            Side[0].Dock[QueuePos].W := RmIRC.Right;
          //TOP QUEUE SIDE LIST
          for QueuePos := 0 to NUM_DOCK do
            Side[1].Dock[QueuePos].X := 0;
          tmp := RToolBar.Bottom;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
          begin
            Side[1].Dock[QueuePos].Y := tmp;
            inc(tmp,Side[1].Dock[QueuePos].H);
          end;
          for QueuePos := 0 to NUM_DOCK do
            Side[1].Dock[QueuePos].W := RmIRC.Right;
          //LEFT QUEUE SIDE LIST
          tmp := 0;
          for QueuePos := 0 to NUM_DOCK do
          begin
            Side[2].Dock[QueuePos].X := tmp;
            inc(tmp,Side[2].Dock[QueuePos].W);
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[2].Dock[QueuePos].Y := tmp;
          tmp := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[2].Dock[QueuePos].H := tmp;
          if (SwitchBarInside) then
            for QueuePos := 0 to NUM_DOCK do
              if (Side[2].Dock[QueuePos].H <= RSwitchBar.Bottom) then
                Side[2].Dock[QueuePos].H := RSwitchBar.Bottom;
          //RIGHT QUEUE SIDE LIST
          tmp := RmIRC.Right;
          for QueuePos := 0 to NUM_DOCK do
          begin
            dec(tmp,Side[3].Dock[QueuePos].W);
            Side[3].Dock[QueuePos].X := tmp;
          end;
          tmp := DocksLeftW;
          for QueuePos := NUM_DOCK downto 0 do
          begin
            if (Side[3].Dock[QueuePos].X <= tmp) then
              Side[3].Dock[QueuePos].X := tmp;
            inc(tmp,Side[3].Dock[QueuePos].W);
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[3].Dock[QueuePos].Y := tmp;

          tmp := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[3].Dock[QueuePos].H := tmp;
          if (SwitchBarInside) then
            for QueuePos := 0 to NUM_DOCK do
              if (Side[3].Dock[QueuePos].H <= RSwitchBar.Bottom) then
                Side[3].Dock[QueuePos].H := RSwitchBar.Bottom;
          //MDI
          MDI_X := DocksLeftW;
          MDI_Y := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(MDI_Y,RStatusBar.Bottom);
          MDI_W := RmIRC.Right - DocksLeftW - DocksRightW;
          MDI_H := RmIRC.Bottom - RToolBar.Bottom - RSwitchBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
        end;
        //TOP CASE
        1: begin
          //SWITCHBAR
          RSwitchBar.Left := 0;
          if (SwitchBarInside) then
            inc(RSwitchBar.Left,DocksLeftW);
          RSwitchBar.Right := RmIRC.Right;
          if (SwitchBarInside) then
          begin
            dec(RSwitchBar.Right,DocksLeftW);
            dec(RSwitchBar.Right,DocksRightW);
          end;
          RSwitchBar.Top := RToolBar.Bottom;
          if (StatusBar.Top) then
            inc(RSwitchBar.Top,RStatusBar.Bottom);
          if (SwitchBarInside) then
            inc(RSwitchBar.Top,DocksTopH);
          //BOTTOM QUEUE SIDE LIST
          for QueuePos := 0 to NUM_DOCK do
            Side[0].Dock[QueuePos].X := 0;
          tmp := RmIRC.Bottom;
          if (not StatusBar.Top) then
            dec(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
          begin
            dec(tmp,Side[0].Dock[QueuePos].H);
            Side[0].Dock[QueuePos].Y := tmp;
          end;
          tmp := RToolBar.Bottom + RSwitchBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := NUM_DOCK downto 0 do
          begin
            if (Side[0].Dock[QueuePos].Y <= tmp) then
              Side[0].Dock[QueuePos].Y := tmp;
            inc(tmp,Side[0].Dock[QueuePos].H);
          end;
          for QueuePos := 0 to NUM_DOCK do
            Side[0].Dock[QueuePos].W := RmIRC.Right;
          //TOP QUEUE SIDE LIST
          for QueuePos := 0 to NUM_DOCK do
            Side[1].Dock[QueuePos].X := 0;
          tmp := RToolBar.Bottom;
          if (not SwitchBarInside) then
            inc(tmp,RSwitchBar.Bottom);
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
          begin
            Side[1].Dock[QueuePos].Y := tmp;
            inc(tmp,Side[1].Dock[QueuePos].H);
          end;
          for QueuePos := 0 to NUM_DOCK do
            Side[1].Dock[QueuePos].W := RmIRC.Right;
          //LEFT QUEUE SIDE LIST
          tmp := 0;
          for QueuePos := 0 to NUM_DOCK do
          begin
            Side[2].Dock[QueuePos].X := tmp;
            inc(tmp,Side[2].Dock[QueuePos].W);
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (not SwitchBarInside) then
            inc(tmp,RSwitchBar.Bottom);
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[2].Dock[QueuePos].Y := tmp;
          tmp := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[2].Dock[QueuePos].H := tmp;
          if (SwitchBarInside) then
            for QueuePos := 0 to NUM_DOCK do
              if (Side[2].Dock[QueuePos].H <= RSwitchBar.Bottom) then
                Side[2].Dock[QueuePos].H := RSwitchBar.Bottom;
          //RIGHT QUEUE SIDE LIST
          tmp := RmIRC.Right;
          for QueuePos := 0 to NUM_DOCK do
          begin
            dec(tmp,Side[3].Dock[QueuePos].W);
            Side[3].Dock[QueuePos].X := tmp;
          end;
          tmp := DocksLeftW;
          for QueuePos := NUM_DOCK downto 0 do
          begin
            if (Side[3].Dock[QueuePos].X <= tmp) then
              Side[3].Dock[QueuePos].X := tmp;
            inc(tmp,Side[3].Dock[QueuePos].W);
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (not SwitchBarInside) then
            inc(tmp,RSwitchBar.Bottom);
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[3].Dock[QueuePos].Y := tmp;
          tmp := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[3].Dock[QueuePos].H := tmp;
          if (SwitchBarInside) then
            for QueuePos := 0 to NUM_DOCK do
              if (Side[3].Dock[QueuePos].H <= RSwitchBar.Bottom) then
                Side[3].Dock[QueuePos].H := RSwitchBar.Bottom;
          //MDI
          MDI_X := DocksLeftW;
          MDI_Y := RToolBar.Bottom + RSwitchBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(MDI_Y,RStatusBar.Bottom);
          MDI_W := RmIRC.Right - DocksLeftW - DocksRightW;
          MDI_H := RmIRC.Bottom - RToolBar.Bottom - RSwitchBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
        end;
        //LEFT CASE
        2: begin
          //SWITCHBAR
          RSwitchBar.Left := 0;
          if (SwitchBarInside) then
            inc(RSwitchBar.Left,DocksLeftW);
          RSwitchBar.Top := RToolBar.Bottom;
          if (StatusBar.Top) then
            inc(RSwitchBar.Top,RStatusBar.Bottom);
          if (SwitchBarInside) then
            inc(RSwitchBar.Top,DocksTopH);
          RSwitchBar.Bottom := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom;
          if (SwitchBarInside) then
          begin
            dec(RSwitchBar.Bottom,DocksBottomH);
            dec(RSwitchBar.Bottom,DocksTopH);
          end;
          //BOTTOM QUEUE SIDE LIST
          tmp := 0;
          if (not SwitchBarInside) then
            inc(tmp,RSwitchBar.Right);
          for QueuePos := 0 to NUM_DOCK do
            Side[0].Dock[QueuePos].X := tmp;
          tmp := RmIRC.Bottom;
          if (not StatusBar.Top) then
            dec(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
          begin
            dec(tmp,Side[0].Dock[QueuePos].H);
            Side[0].Dock[QueuePos].Y := tmp;
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := NUM_DOCK downto 0 do
          begin
            if (Side[0].Dock[QueuePos].Y <= tmp) then
              Side[0].Dock[QueuePos].Y := tmp;
            inc(tmp,Side[0].Dock[QueuePos].H);
          end;
          tmp := RmIRC.Right;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Right);
          for QueuePos := 0 to NUM_DOCK do
            Side[0].Dock[QueuePos].W := tmp;
          //TOP QUEUE SIDE LIST
          tmp := 0;
          if (not SwitchBarInside) then
            inc(tmp,RSwitchBar.Right);
          for QueuePos := 0 to NUM_DOCK do
            Side[1].Dock[QueuePos].X := tmp;
          tmp := RToolBar.Bottom;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
          begin
            Side[1].Dock[QueuePos].Y := tmp;
            inc(tmp,Side[1].Dock[QueuePos].H);
          end;
          tmp := RmIRC.Right;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Right);
          for QueuePos := 0 to NUM_DOCK do
            Side[1].Dock[QueuePos].W := tmp;
          //LEFT QUEUE SIDE LIST
          tmp := 0;
          if (not SwitchBarInside) then
            inc(tmp,RSwitchBar.Right);
          for QueuePos := 0 to NUM_DOCK do
          begin
            Side[2].Dock[QueuePos].X := tmp;
            inc(tmp,Side[2].Dock[QueuePos].W);
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[2].Dock[QueuePos].Y := tmp;
          tmp := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
          for QueuePos := 0 to NUM_DOCK do
            Side[2].Dock[QueuePos].H := tmp;
          //RIGHT QUEUE SIDE LIST
          tmp := RmIRC.Right;
          for QueuePos := 0 to NUM_DOCK do
          begin
            dec(tmp,Side[3].Dock[QueuePos].W);
            Side[3].Dock[QueuePos].X := tmp;
          end;
          tmp := RSwitchBar.Right + DocksLeftW;
          for QueuePos := NUM_DOCK downto 0 do
          begin
            if (Side[3].Dock[QueuePos].X <= tmp) then
              Side[3].Dock[QueuePos].X := tmp;
            inc(tmp,Side[3].Dock[QueuePos].W);
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[3].Dock[QueuePos].Y := tmp;
          tmp := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
          for QueuePos := 0 to NUM_DOCK do
            Side[3].Dock[QueuePos].H := tmp;
          //MDI
          MDI_X := RSwitchBar.Right + DocksLeftW;
          MDI_Y := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(MDI_Y,RStatusBar.Bottom);
          MDI_W := RmIRC.Right - RSwitchBar.Right - DocksLeftW - DocksRightW;
          MDI_H := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
        end;
        //RIGHT CASE
        3: begin
          //SWITCHBAR
          RSwitchBar.Left := RmIRC.Right - RSwitchBar.Right;
          if (SwitchBarInside) then
            dec(RSwitchBar.Left,DocksRightW);
          tmp := DocksLeftW;
          if (not SwitchBarInside) then
            inc(tmp,DocksRightW);
          if (RSwitchBar.Left <= tmp) then
            RSwitchBar.Left := tmp;
          RSwitchBar.Top := RToolBar.Bottom;
          if (StatusBar.Top) then
            inc(RSwitchBar.Top,RStatusBar.Bottom);
          if (SwitchBarInside) then
            inc(RSwitchBar.Top,DocksTopH);
          RSwitchBar.Bottom := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom;
          if (SwitchBarInside) then
          begin
            dec(RSwitchBar.Bottom,DocksBottomH);
            dec(RSwitchBar.Bottom,DocksTopH);
          end;
          //BOTTOM QUEUE SIDE LIST
          for QueuePos := 0 to NUM_DOCK do
            Side[0].Dock[QueuePos].X := 0;
          tmp := RmIRC.Bottom;
          if (not StatusBar.Top) then
            dec(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
          begin
            dec(tmp,Side[0].Dock[QueuePos].H);
            Side[0].Dock[QueuePos].Y := tmp;
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := NUM_DOCK downto 0 do
          begin
            if (Side[0].Dock[QueuePos].Y <= tmp) then
              Side[0].Dock[QueuePos].Y := tmp;
            inc(tmp,Side[0].Dock[QueuePos].H);
          end;
          tmp := RmIRC.Right;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Right);
          for QueuePos := 0 to NUM_DOCK do
            Side[0].Dock[QueuePos].W := tmp;
          tmp := DocksLeftW + DocksRightW;
          for QueuePos := 0 to NUM_DOCK do
            if (Side[0].Dock[QueuePos].W <= tmp) then
              Side[0].Dock[QueuePos].W := tmp;
          //TOP QUEUE SIDE LIST
          for QueuePos := 0 to NUM_DOCK do
            Side[1].Dock[QueuePos].X := 0;
          tmp := RToolBar.Bottom;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
          begin
            Side[1].Dock[QueuePos].Y := tmp;
            inc(tmp,Side[1].Dock[QueuePos].H);
          end;
          tmp := RmIRC.Right;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Right);
          for QueuePos := 0 to NUM_DOCK do
            Side[1].Dock[QueuePos].W := tmp;
          tmp := DocksLeftW + DocksRightW;
          for QueuePos := 0 to NUM_DOCK do
            if (Side[1].Dock[QueuePos].W <= tmp) then
              Side[1].Dock[QueuePos].W := tmp;
          //LEFT QUEUE SIDE LIST
          tmp := 0;
          for QueuePos := 0 to NUM_DOCK do
          begin
            Side[2].Dock[QueuePos].X := tmp;
            inc(tmp,Side[2].Dock[QueuePos].W);
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[2].Dock[QueuePos].Y := tmp;
          tmp := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
          for QueuePos := 0 to NUM_DOCK do
            Side[2].Dock[QueuePos].H := tmp;
          //RIGHT QUEUE SIDE LIST
          tmp := RmIRC.Right;
          if (not SwitchBarInside) then
            dec(tmp,RSwitchBar.Right);
          for QueuePos := 0 to NUM_DOCK do
          begin
            dec(tmp,Side[3].Dock[QueuePos].W);
            Side[3].Dock[QueuePos].X := tmp;
          end;
          tmp := DocksLeftW;
          if (SwitchBarInside) then
            inc(tmp,RSwitchBar.Right);
          for QueuePos := NUM_DOCK downto 0 do
          begin
            if (Side[3].Dock[QueuePos].X <= tmp) then
              Side[3].Dock[QueuePos].X := tmp;
            inc(tmp,Side[3].Dock[QueuePos].W);
          end;
          tmp := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(tmp,RStatusBar.Bottom);
          for QueuePos := 0 to NUM_DOCK do
            Side[3].Dock[QueuePos].Y := tmp;
          tmp := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
          for QueuePos := 0 to NUM_DOCK do
            Side[3].Dock[QueuePos].H := tmp;
          //MDI
          MDI_X := DocksLeftW;
          MDI_Y := RToolBar.Bottom + DocksTopH;
          if (StatusBar.Top) then
            inc(MDI_Y,RStatusBar.Bottom);
          MDI_W := RmIRC.Right - RSwitchBar.Right - DocksLeftW - DocksRightW;
          MDI_H := RmIRC.Bottom - RToolBar.Bottom - RStatusBar.Bottom - DocksBottomH - DocksTopH;
        end;
      end;
      SendMessage(StatusBar.Handle,WM_SIZE,0,0);
      if (StatusBar.Top) then
        RToolBar.Top := RStatusBar.Bottom;
      if (IsWindowVisible(mIRCHToolBar)) then
        MoveWindow(mIRCHToolBar,0,RToolBar.Top,RmIRC.Right,RToolBar.Bottom,true);
      for SidePos := 0 to 3 do
        for QueuePos := 0 to NUM_DOCK do
          if (IsWindow(Side[SidePos].Dock[QueuePos].Handle)) then
          begin
            MoveWindow(Side[SidePos].Dock[QueuePos].Handle,Side[SidePos].Dock[QueuePos].X,Side[SidePos].Dock[QueuePos].Y,Side[SidePos].Dock[QueuePos].W,Side[SidePos].Dock[QueuePos].H,true);
            Signal('DOCKRESIZE '+Side[SidePos].Dock[QueuePos].Name+' '+inttostr(Side[SidePos].Dock[QueuePos].W)+' '+inttostr(Side[SidePos].Dock[QueuePos].H));
          end;
      if (IsWindowVisible(mIRCHSwitchBar)) then
        MoveWindow(mIRCHSwitchBar,RSwitchBar.Left,RSwitchBar.Top,RSwitchBar.Right,RSwitchBar.Bottom,true);
      MoveWindow(mIRCHMDI,MDI_X,MDI_Y,MDI_W,MDI_H,true);
      Signal('MIRCRESIZE '+inttostr(RmIRC.Right)+' '+inttostr(RmIRC.Bottom));
      Result := 0;
      exit;
    end;
    WM_SETTEXT: begin
      if (TitleBar <> '') then
        lP := LParam(PChar(trim(TitleBar+' '+GetTok(PChar(lP),#32,-2))));
    end;
    //statusbar text draw
    WM_DRAWITEM: begin
      CopyMemory(@DrawStruct,Pointer(lP),SizeOf(DrawStruct));
      Icon := SendMessage(StatusBar.Handle,SB_GETICON,DrawStruct.itemID,0);
      GetIconInfo(Icon,IconSize);
      RStatusBar := DrawStruct.rcItem;
      if (Icon <> 0) then
        inc(RStatusBar.Left,IconSize.xHotspot * 2 + 5)
      else
        inc(RStatusBar.Left);
      DeleteObject(IconSize.hbmMask);
      DeleteObject(IconSize.hbmColor);
      dec(RStatusBar.Right);
      if (RStatusBar.Right >= 0) then
        FormatText(DrawStruct.hDC,pChar(StatusBar.Text[DrawStruct.itemID]),RStatusBar);
    end;
    WM_CLOSE: begin
      Result := 0;
      SetWindowLong(Handle,GWL_WNDPROC,Longint(mIRCPProc));
      PostMessage(Handle,Msg,wP,lP);
      exit;
    end;
  end;
  Result := CallWindowProc(mIRCPProc,Handle,Msg,wP,lP);
end;

function SwitchBarWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall;
var
  tmp: String;
begin
  case Msg of
    WM_SHOWWINDOW: begin
      PosSwitchBar;
      case SwitchBarPosition of
        0: tmp := 'BOTTOM';
        1: tmp := 'TOP';
        2: tmp := 'LEFT';
        3: tmp := 'RIGHT';
      end;
      Signal('SWITCHBAR '+tmp);
      PostMessage(mIRCHandle,WM_SIZE,0,0);
    end;
  end;
  Result := CallWindowProc(SwitchBarPProc,Handle,Msg,wP,lP);
end;

function DockWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall;
begin
  if (Msg = WM_CLOSE) then  //BLOCK WINDOWS CLOSE
  begin
    Result := 0;
    exit;
  end;
  Result := CallWindowProc(GetDockPProc(Handle),Handle,Msg,wP,lP);
end;

function StatusBarWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall;
var
  tmp: String;
  Panel: Integer;
  DrawStruct: DRAWITEMSTRUCT;
begin
  case Msg of
    WM_LBUTTONDOWN: Signal('STATUSBAR LEFTDOWN '+inttostr(GetPanelStatusBar(lP)));
    WM_LBUTTONUP: Signal('STATUSBAR LEFTUP '+inttostr(GetPanelStatusBar(lP)));
    WM_RBUTTONDOWN: Signal('STATUSBAR RIGHTDOWN '+inttostr(GetPanelStatusBar(lP)));
    WM_RBUTTONUP: Signal('STATUSBAR RIGHTUP '+inttostr(GetPanelStatusBar(lP)));
    WM_LBUTTONDBLCLK: Signal('STATUSBAR LEFTDBLCLK '+inttostr(GetPanelStatusBar(lP)));
    WM_RBUTTONDBLCLK: Signal('STATUSBAR RIGHTDBLCLK '+inttostr(GetPanelStatusBar(lP)));
    WM_SIZE: ResizeStatusBar;
    //trackbar notification
    WM_HSCROLL,WM_VSCROLL: begin
      tmp := inttostr(SendMessage(lP,TBM_GETPOS,0,0))+' '
        +inttostr(SendMessage(lP,TBM_GETRANGEMIN,0,0))+' '
        +inttostr(SendMessage(lP,TBM_GETRANGEMAX,0,0))+' '
        +inttostr(SendMessage(lP,TBM_GETLINESIZE,0,0))+' '
        +inttostr(SendMessage(lP,TBM_GETPAGESIZE,0,0))+' '
        +inttostr(SendMessage(lP,TBM_GETSELSTART,0,0))+' '
        +inttostr(SendMessage(lP,TBM_GETSELEND,0,0))+' '
        +inttostr(SendMessage(lP,TBM_GETTHUMBLENGTH,0,0));
      tmp := inttostr(GetPanelFromCtrlHwnd(lP)+1)+' '+tmp;
      case LoWord(wP) of
        TB_ENDTRACK: tmp := 'END '+tmp;
        TB_LINEUP,TB_LINEDOWN: tmp := 'LINE '+tmp;
        TB_PAGEUP,TB_PAGEDOWN: tmp := 'PAGE '+tmp;
        TB_TOP,TB_BOTTOM: tmp := 'JUMP '+tmp;
        TB_THUMBTRACK,TB_THUMBPOSITION: tmp := 'TRACK '+tmp;
      end;
      Signal('TRACKBAR '+tmp);
    end;
    //button draw and colors
    WM_DRAWITEM: begin
      CopyMemory(@DrawStruct,Pointer(lP),SizeOf(DrawStruct));
      Panel := GetPanelFromCtrlHwnd(DrawStruct.hwndItem);
      if ((DrawStruct.itemState and ODS_SELECTED) > 0) then
        Button_Pressed(DrawStruct,Panel)
      else
        Button_Unpressed(DrawStruct,Panel);
    end;
  end;
  Result := CallWindowProc(StatusBar.PProc,Handle,Msg,wP,lP);
end;

function ProgressBarWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall;
var
  n,prc: Integer;
  tmp: Longint;
  c: TPoint;
  r: TRect;
  Range: PBRANGE;
begin
  n := GetPanelFromCtrlHwnd(Handle);
  if (Msg = WM_SETCURSOR) then
  begin
    if ((StatusBar.ProgressBar[n].Track) and (StatusBar.ProgressBar[n].HandCurs)) then
      SetCursor(LoadCursor(0,IDC_HAND));
    Result := 0;
    exit;
  end;
  Result := CallWindowProc(StatusBar.ProgressBar[n].PProc,Handle,Msg,wP,lP);
  case Msg of
    WM_LBUTTONDOWN: begin
      Signal('PROGRESSBAR LEFTDOWN '+inttostr(n+1));
      if (StatusBar.ProgressBar[n].Track) then
        SetTimer(Handle,PROGRESSBAR_TIMER,0,nil);
    end;
    WM_LBUTTONUP: if (not StatusBar.ProgressBar[n].Track) then Signal('PROGRESSBAR LEFTUP '+inttostr(n+1));
    WM_RBUTTONDOWN: Signal('PROGRESSBAR RIGHTDOWN '+inttostr(n+1));
    WM_RBUTTONUP: Signal('PROGRESSBAR RIGHTUP '+inttostr(n+1));
    WM_LBUTTONDBLCLK: Signal('PROGRESSBAR LEFTDBLCLK '+inttostr(n+1));
    WM_RBUTTONDBLCLK: Signal('PROGRESSBAR RIGHTDBLCLK '+inttostr(n+1));
    WM_TIMER: if (wP = PROGRESSBAR_TIMER) then begin
      GetCursorPos(c);
      ScreenToClient(Handle,c);
      GetClientRect(Handle,r);
      if (StatusBar.ProgressBar[n].Vertical) then
        prc := (c.Y - r.Bottom) * 100 div r.Bottom * -1
      else
        prc := c.X * 100 div (r.Right-r.Left);
      if (prc < 0) then
        prc := 0
      else if (prc > 100) then
        prc := 100;
      SendMessage(Handle,PBM_GETRANGE,0,lParam(@Range));
      tmp := Range.iLow + (Range.iHigh - Range.iLow) div 100 * prc;
      if (GetKeyState(VK_LBUTTON) >= 0) then
      begin
        KillTimer(Handle,PROGRESSBAR_TIMER);
        Signal('PROGRESSBAR LEFTUP '+inttostr(n+1));
      end
      else if (SendMessage(Handle,PBM_GETPOS,0,0) <> tmp) then
      begin
        SendMessage(Handle,PBM_SETPOS,tmp,0);
        Signal('PROGRESSBAR TRACK '+inttostr(n+1)+' '+inttostr(SendMessage(Handle,PBM_GETPOS,0,0))+' '+inttostr(Range.iLow)+' '+inttostr(Range.iHigh)+' '+inttostr(prc));
      end;
    end;
  end;
end;

function WindowWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall;
var
  n: Integer;
begin
  n := GetPanelFromCtrlHwnd(Handle);
  case Msg of
    WM_CLOSE: begin
      Result := 0;
      exit;
    end;
    WM_SIZE: Signal('WINDOW RESIZE '+inttostr(n+1)+' '+StatusBar.Window[n].Name+' '+inttostr(LoWord(lP))+' '+inttostr(HiWord(lP)));
  end;
  Result := CallWindowProc(StatusBar.Window[n].PProc,Handle,Msg,wP,lP);
end;

function ButtonWProc(Handle: hWnd; Msg,wP,lP: Longint): Longint; stdcall;
var
  n: Integer;
  TME: tagTRACKMOUSEEVENT;
begin
  n := GetPanelFromCtrlHwnd(Handle);
  case Msg of
    WM_LBUTTONDOWN: Signal('BUTTON LEFTDOWN '+inttostr(n+1));
    WM_LBUTTONUP: Signal('BUTTON LEFTUP '+inttostr(n+1));
    WM_LBUTTONDBLCLK: Signal('BUTTON LEFTDBLCLK '+inttostr(n+1));
    WM_RBUTTONDOWN: Signal('BUTTON RIGHTDOWN '+inttostr(n+1));
    WM_RBUTTONUP: Signal('BUTTON RIGHTUP '+inttostr(n+1));
    WM_RBUTTONDBLCLK: Signal('BUTTON RIGHTDBLCLK '+inttostr(n+1));
    WM_MOUSEMOVE: begin
      if (StatusBar.Button[n].bTipTrack) then
      begin
        SendMessage(StatusBar.Button[n].TipHandle,TTM_TRACKACTIVATE,1,lParam(@StatusBar.Button[n].TipInfo));
        SendMessage(StatusBar.Button[n].TipHandle,TTM_TRACKPOSITION,0,lP);
      end;
      if (not StatusBar.Button[n].tme) then
      begin
        TME.cbSize := SizeOf(TME);
        TME.dwFlags := TME_LEAVE or TME_HOVER;
        TME.hwndTrack := Handle;
        TME.dwHoverTime := 1;
        StatusBar.Button[n].tme := _TrackMouseEvent(@TME);
      end;
    end;
    WM_MOUSELEAVE: begin
      if (StatusBar.Button[n].bTipTrack) then
        ShowWindow(StatusBar.Button[n].TipHandle,SW_HIDE);
      lstrcpy(StatusBar.Button[n].TipInfo.lpszText,pChar(StatusBar.Button[n].TipText));
      SendMessage(StatusBar.Button[n].TipHandle,TTM_ADDTOOL,0,lParam(@StatusBar.Button[n].TipInfo));
      if (not StatusBar.Button[n].bTipTrack) then
        SendMessage(StatusBar.Button[n].TipHandle,TTM_ACTIVATE,1,0);
      StatusBar.Button[n].hover := false;
      StatusBar.Button[n].tme := false;
      InvalidateRect(Handle,nil,true);
    end;
    WM_MOUSEHOVER: begin
      StatusBar.Button[n].hover := true;
      InvalidateRect(Handle,nil,true);
    end;
  end;
  Result := CallWindowProc(StatusBar.Button[n].PProc,Handle,Msg,wP,lP);
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////

//<window name> <side position> <side queue position> [window size] [styles]
function Dock(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  Handle: hWnd;
  Window,tmp,tmp2: String;
  n,E,SidePos,QueuePos,WindowSize: Integer;
  Style,ExStyle: Longint;
  ClassName: array [0..15] of Char;
  r: TRect;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  Window := PopTok(tmp,#32);
  Handle := GetHwnd(Window);
  if (not IsWindow(Handle)) then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW');
    exit;
  end;
  GetClassName(Handle,ClassName,15);
  if (ClassName <> 'mIRC_Custom') and (ClassName <> '#32770') then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW');
    exit;
  end;
  if (IsDock(Handle)) then
  begin
    lstrcpy(data,'ERROR: WINDOW ALREADY DOCKED');
    exit;
  end;
  tmp2 := PopTok(tmp,#32);
  if (tmp2 = 'BOTTOM') then
    SidePos := 0
  else if (tmp2 = 'LEFT') then
    SidePos := 2
  else if (tmp2 = 'TOP') then
    SidePos := 1
  else if (tmp2 = 'RIGHT') then
    SidePos := 3
  else
  begin
    lstrcpy(data,'ERROR: INVALID SIDE POSITION');
    exit;
  end;
  val(PopTok(tmp,#32),QueuePos,E);
  if ((E > 0) or ((QueuePos < -1) or (QueuePos > NUM_DOCK))) then
  begin
    lstrcpy(data,'ERROR: INVALID QUEUE POSITION');
    exit;
  end;
  if (QueuePos = -1) then
  begin
    for n := 0 to NUM_DOCK+1 do
      if (not IsWindow(Side[SidePos].Dock[n].Handle)) then
        break;
    if (n = NUM_DOCK+1) then
    begin
      lstrcpy(data,'ERROR: SIDE QUEUE FULL');
      exit;
    end
    else
      QueuePos := n;
  end;
  if (IsWindow(Side[SidePos].Dock[QueuePos].Handle)) then
  begin
    lstrcpy(data,'ERROR: QUEUE POSITION ALREADY IN USE');
    exit;
  end;
  Side[SidePos].Dock[QueuePos].Name := Window;
  Side[SidePos].Dock[QueuePos].Handle := Handle;
  Side[SidePos].Dock[QueuePos].PProc := Pointer(SetWindowLong(Handle,GWL_WNDPROC,Longint(@DockWProc)));
  Side[SidePos].Dock[QueuePos].X := 0;
  Side[SidePos].Dock[QueuePos].Y := 0;
  GetClientRect(Handle,r);
  Side[SidePos].Dock[QueuePos].W := r.Right;
  Side[SidePos].Dock[QueuePos].H := r.Bottom;
  Side[SidePos].Dock[QueuePos].BackParent := GetParent(Handle);
  Side[SidePos].Dock[QueuePos].BackStyle := GetWindowLong(Handle,GWL_STYLE);
  Side[SidePos].Dock[QueuePos].BackExStyle := GetWindowLong(Handle,GWL_EXSTYLE);
  Side[SidePos].Dock[QueuePos].BackW := r.Right;
  Side[SidePos].Dock[QueuePos].BackH := r.Bottom;
  GetWindowRect(Handle,r);
  Side[SidePos].Dock[QueuePos].BackX := r.Left;
  Side[SidePos].Dock[QueuePos].BackY := r.Top;
  GetWindowRect(GetParent(Handle),r);
  dec(Side[SidePos].Dock[QueuePos].BackX,r.Left);
  dec(Side[SidePos].Dock[QueuePos].BackY,r.Top);
  tmp2 := tmp;
  val(PopTok(tmp,#32),WindowSize,E);
  if (E = 0) then
  begin
    if (SidePos in [0..1]) then
      Side[SidePos].Dock[QueuePos].H := WindowSize
    else
      Side[SidePos].Dock[QueuePos].W := WindowSize;
  end
  else
    tmp := tmp2;
  Style := GetWindowLong(Handle,GWL_STYLE) and not (WS_POPUP or WS_CAPTION or WS_BORDER or WS_DLGFRAME or WS_SIZEBOX) or WS_CHILD or WS_VISIBLE;
  ExStyle := GetWindowLong(Handle,GWL_EXSTYLE) and not (WS_EX_DLGMODALFRAME or WS_EX_WINDOWEDGE or WS_EX_CLIENTEDGE or WS_EX_STATICEDGE);
  if (IsTok(tmp,'WindowEdge',#32)) then
    ExStyle := ExStyle or WS_EX_WINDOWEDGE;
  if (IsTok(tmp,'ClientEdge',#32)) then
    ExStyle := ExStyle or WS_EX_CLIENTEDGE;
  if (IsTok(tmp,'StaticEdge',#32)) then
    ExStyle := ExStyle or WS_EX_STATICEDGE;
  if (IsTok(tmp,'DlgModal',#32)) then
    ExStyle := ExStyle or WS_EX_DLGMODALFRAME;
  if (IsTok(tmp,'Border',#32)) then
    Style := Style or WS_BORDER;
  if (IsTok(tmp,'DlgFrame',#32)) then
    Style := Style or WS_DLGFRAME;
  SetWindowLong(Handle,GWL_STYLE,Style);
  SetWindowLong(Handle,GWL_EXSTYLE,ExStyle);
  SetParent(Handle,mIRCHandle);
  SetFocus(mIRCHandle);
  SendMessage(mIRCHandle,WM_SIZE,0,0);
end;

//<window name> [close]
function Undock(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  Handle: hWnd;
  Window,tmp: String;
  SidePos,QueuePos: Integer;
  ClassName: array [0..15] of Char;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  Window := PopTok(tmp,#32);
  Handle := GetHwnd(Window);
  if (not IsWindow(Handle)) then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW');
    exit;
  end;
  GetClassName(Handle,ClassName,15);
  if (ClassName <> 'mIRC_Custom') and (ClassName <> '#32770') then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW');
    exit;
  end;
  for SidePos := 0 to 3 do
    for QueuePos := 0 to NUM_DOCK do
      if (Side[SidePos].Dock[QueuePos].Handle = Handle) then
      begin
        if (Side[SidePos].Dock[QueuePos].PProc <> nil) then
          SetWindowLong(Handle,GWL_WNDPROC,Longint(Side[SidePos].Dock[QueuePos].PProc));
        if (PopTok(tmp,#32) = 'CLOSE') then
        begin
          if (ClassName = 'mIRC_Custom') then
            SendData('window -c '+Side[SidePos].Dock[QueuePos].Name)
          else
            SendData('dialog -x '+Side[SidePos].Dock[QueuePos].Name);
        end;
        SetWindowLong(Handle,GWL_STYLE,Side[SidePos].Dock[QueuePos].BackStyle);
        SetWindowLong(Handle,GWL_EXSTYLE,Side[SidePos].Dock[QueuePos].BackExStyle);
        SetWindowPos(Handle,Side[SidePos].Dock[QueuePos].BackParent,
          Side[SidePos].Dock[QueuePos].BackX,Side[SidePos].Dock[QueuePos].BackY,
          Side[SidePos].Dock[QueuePos].BackW,Side[SidePos].Dock[QueuePos].BackH,
          SWP_NOZORDER or SWP_FRAMECHANGED or SWP_NOOWNERZORDER);
        Side[SidePos].Dock[QueuePos].Name := '';
        Side[SidePos].Dock[QueuePos].Handle := 0;
        Side[SidePos].Dock[QueuePos].PProc := nil;
        Side[SidePos].Dock[QueuePos].X := 0;
        Side[SidePos].Dock[QueuePos].Y := 0;
        Side[SidePos].Dock[QueuePos].W := 0;
        Side[SidePos].Dock[QueuePos].H := 0;
        Side[SidePos].Dock[QueuePos].BackParent := 0;
        Side[SidePos].Dock[QueuePos].BackStyle := 0;
        Side[SidePos].Dock[QueuePos].BackExStyle := 0;
        Side[SidePos].Dock[QueuePos].BackW := 0;
        Side[SidePos].Dock[QueuePos].BackH := 0;
        Side[SidePos].Dock[QueuePos].BackX := 0;
        Side[SidePos].Dock[QueuePos].BackY := 0;
        SendMessage(mIRCHandle,WM_SIZE,0,0);
        exit;
      end;
  lstrcpy(data,'ERROR: WINDOW ISN''T DOCKED');
end;

//<inside | outside>
function DockSwitchBarInOut(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  tmp := PopTok(tmp,#32);
  if (tmp = 'INSIDE') then
    SwitchBarInside := true
  else if (tmp = 'OUTSIDE') then
    SwitchBarInside := false
  else
  begin
    lstrcpy(data,'ERROR: INVALID PARAMETER');
    exit;
  end;
  SendMessage(mIRCHandle,WM_SIZE,0,0);
end;

//<window name> <#size>
function DockSize(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  Handle: hWnd;
  Window,tmp: String;
  SidePos,QueuePos,n,E: Integer;
  ClassName: array [0..15] of Char;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  Window := PopTok(tmp,#32);
  Handle := GetHwnd(Window);
  if (not IsWindow(Handle)) then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW');
    exit;
  end;
  GetClassName(Handle,ClassName,15);
  if (ClassName <> 'mIRC_Custom') and (ClassName <> '#32770') then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW');
    exit;
  end;
  for SidePos := 0 to 3 do
    for QueuePos := 0 to NUM_DOCK do
      if (Side[SidePos].Dock[QueuePos].Handle = Handle) then
      begin
        val(PopTok(tmp,#32),n,E);
        if (E > 0) then
        begin
          lstrcpy(data,'ERROR: INVALID SIZE');
          exit;
        end;
        if (SidePos in [0..1]) then
          Side[SidePos].Dock[QueuePos].H := n
        else
          Side[SidePos].Dock[QueuePos].W := n;
        SetWindowPos(Handle,0,0,0,Side[SidePos].Dock[QueuePos].W,Side[SidePos].Dock[QueuePos].H,
          SWP_NOZORDER or SWP_NOOWNERZORDER or SWP_NOACTIVATE or SWP_NOMOVE);
        SendMessage(mIRCHandle,WM_SIZE,0,0);
        exit;
      end;
  lstrcpy(data,'ERROR: WINDOW ISN''T DOCKED');
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////

//[noxptheme | sizegrip | top]
function AddStatusBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Style: Longint;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR ALREADY IN USE');
    exit;
  end;
  Style := WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_CLIPCHILDREN or SBT_TOOLTIPS or CCS_BOTTOM;
  if (IsTok(tmp,'SizeGrip',#32)) then
    Style := Style or SBARS_SIZEGRIP;
  StatusBar.Top := false;
  if (IsTok(tmp,'Top',#32)) then
  begin
    Style := Style and not (CCS_BOTTOM or SBARS_SIZEGRIP) or CCS_TOP;
    StatusBar.Top := true;
  end;
  StatusBar.Handle := CreateWindowEx(0,STATUSBAR_CLASS,nil,Style,0,0,0,0,mIRCHandle,STATUSBAR_ID,0,nil);
  if (IsTok(tmp,'NoXPTheme',#32)) then
    SetWTheme(StatusBar.Handle,false);
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: CAN''T CREATE THE STATUSBAR');
    exit;
  end;
  StatusBar.PProc := Pointer(SetWindowLong(StatusBar.Handle,GWL_WNDPROC,Longint(@StatusBarWProc)));
  SendMessage(mIRCHandle,WM_SIZE,0,0);
end;

function RemStatusBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
begin
  Result := 3;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  DestroyStatusBar;
  SendMessage(mIRCHandle,WM_SIZE,0,0);
end;

function SBSetPanels(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  E,p,n: Integer;
  Parts: array [0..255] of Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  n := NumTok(tmp,#32);
  if ((n < 1) and (n > 256)) then
  begin
    lstrcpy(data,'ERROR: SPECIFIES A NUMBER OF PANELS AMONG 1 AND 256');
    exit;
  end;
  for p := 1 to n do
  begin
    val(PopTok(tmp,#32),Parts[p-1],E);
    if (E > 0) then
    begin
      lstrcpy(data,'ERROR: INVALID PANEL SIZE');
      exit;
    end;
  end;
  SendMessage(StatusBar.Handle,SB_SETPARTS,n,lParam(@Parts));
  SendMessage(StatusBar.Handle,WM_SIZE,0,0);
end;

function SBSetHeight(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  E,n: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),n,E);
  if (E > 0) then
  begin
   lstrcpy(data,'ERROR: INVALID SIZE');
   exit;
  end;
  SendMessage(StatusBar.Handle,SB_SETMINHEIGHT,n,0);
  SendMessage(StatusBar.Handle,WM_SIZE,0,0);
  SendMessage(mIRCHandle,WM_SIZE,0,0);
end;

//<#panel> [+npc] [#icon] [text] $chr(9) [tip text]
function SBSetData(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,tmp2,Styles: String;
  E,Panel,IconId,Style: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;

  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  tmp2 := tmp;
  Styles := PopTok(tmp,#32);
  Style := 0;
  if (CharIsIn(Styles,'+')) then
  begin
    if (CharIsIn(Styles,'N')) then
      Style := Style or SBT_NOBORDERS;
    if (CharIsIn(Styles,'P')) then
      Style := Style or SBT_POPOUT;
    if (CharIsIn(Styles,'C')) then
      Style := Style or SBT_OWNERDRAW;
  end
  else
    tmp := tmp2;
  tmp2 := tmp;
  val(PopTok(tmp,#32),IconId,E);
  if (E > 0) then
  begin
    IconId := 0;
    tmp := tmp2;
  end;
  DestroyIcon(SendMessage(StatusBar.Handle,SB_GETICON,Panel-1,0));
  SendMessage(StatusBar.Handle,SB_SETICON,Panel-1,ImageList_GetIcon(StatusBar.ImageList,IconId-1,0));
  StatusBar.Text[Panel-1] := GetTok(tmp,#9,1);
  SendMessage(StatusBar.Handle,SB_SETTEXT,Panel-1 or Style,lParam(pChar(GetTok(tmp,#9,1))));
  SendMessage(StatusBar.Handle,SB_SETTIPTEXT,Panel-1,lParam(pChar(GetTok(tmp,#9,2))));
end;

//<small | large>
function SBCreateIconList(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  tmp := PopTok(tmp,#32);
  if (tmp = 'SMALL') then
  begin
    StatusBar.ImageList := ImageList_Create(16,16,ILC_COLOR32 or ILC_MASK,1,0);
    ImageList_SetBkColor(StatusBar.ImageList,CLR_DEFAULT);
  end
  else if (tmp = 'LARGE') then
  begin
    StatusBar.ImageList := ImageList_Create(32,32,ILC_COLOR32 or ILC_MASK,1,0);
    ImageList_SetBkColor(StatusBar.ImageList,CLR_DEFAULT);
  end
  else
    lstrcpy(data,'ERROR: INVALID PARAMETER');
end;

function SBDestroyIconList(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
begin
  Result := 3;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  ImageList_Destroy(StatusBar.ImageList);
end;

//<[#id,]iconfilename>
function SBAddIcon(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,tmp2: String;
  E,IconId,Size: Integer;
  hIcon16,hIcon32: hIcon;
begin
  Result := 3;
  tmp := trim(data);
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  tmp2 := tmp;
  val(PopTok(tmp,#44),IconId,E);
  if (E > 0) then
  begin
    tmp := tmp2;
    IconId := 0;
  end;
  if (ExtractIconEx(pChar(tmp),IconId,hIcon32,hIcon16,1) > 0) then
  begin
    ImageList_GetIconSize(StatusBar.ImageList,Size,Size);
    if (Size = 32) then
      ImageList_AddIcon(StatusBar.ImageList,hIcon32)
    else
      ImageList_AddIcon(StatusBar.ImageList,hIcon16);
  end
  else
    lstrcpy(data,'ERROR: INVALID ICON');
  DestroyIcon(hIcon16);
  DestroyIcon(hIcon32);
end;

//[-aisu] <#size> <#weight> <font name>
function SBSetFont(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,tmp2,Styles: String;
  E: Integer;
  Font: tagLOGFONT;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  tmp2 := tmp;
  Styles := PopTok(tmp,#32);
  Font.lfQuality := NONANTIALIASED_QUALITY;
  Font.lfItalic := 0;
  Font.lfStrikeOut := 0;
  Font.lfUnderline := 0;
  if (CharIsIn(Styles,'-')) then
  begin
    if (CharIsIn(Styles,'A')) then
      Font.lfQuality := ANTIALIASED_QUALITY;
    if (CharIsIn(Styles,'I')) then
      Font.lfItalic := 1;
    if (CharIsIn(Styles,'S')) then
      Font.lfStrikeOut := 1;
    if (CharIsIn(Styles,'U')) then
      Font.lfUnderline := 1;
  end
  else
    tmp := tmp2;
  val(PopTok(tmp,#32),Font.lfHeight,E);
  if (E > 0) then
  begin
   lstrcpy(data,'ERROR: INVALID SIZE');
   exit;
  end;
  val(PopTok(tmp,#32),Font.lfWeight,E);
  if ((E > 0) or ((Font.lfWeight < 0) and (Font.lfWeight > 700))) then
  begin
   lstrcpy(data,'ERROR: INVALID WEIGHT');
   exit;
  end;
  Font.lfWidth := 0;
  Font.lfEscapement := GM_COMPATIBLE;
  Font.lfOrientation := 0;
  Font.lfCharSet := DEFAULT_CHARSET;
  Font.lfOutPrecision := OUT_CHARACTER_PRECIS;
  Font.lfClipPrecision := CLIP_CHARACTER_PRECIS;
  Font.lfPitchAndFamily := DEFAULT_PITCH;
  lstrcpy(Font.lfFaceName,PChar(tmp));
  SendMessage(StatusBar.Handle,WM_SETFONT,CreateFontIndirect(Font),1);
end;

//<#rgb | default>
function SBSetBGColor(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  E: Integer;
  nRGB: Cardinal;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  tmp := PopTok(tmp,#32);
  if (tmp = 'DEFAULT') then
    nRGB := CLR_DEFAULT
  else
  begin
    val(tmp,nRGB,E);
    if (E > 0) then
    begin
      lstrcpy(data,'ERROR: INVALID RGB VALUE');
      exit;
    end;
  end;
  SendMessage(StatusBar.Handle,SB_SETBKCOLOR,0,nRGB);
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////

//<#panel> [noxptheme | vertical | smooth | marquee | track | handcurs]
function AddProgressBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Style,ExStyle: Longint;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 0) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR PANEL IS ALREADY IN USE');
    exit;
  end;
  Style := WS_CHILD or WS_VISIBLE;
  ExStyle := 0;
  if (IsTok(tmp,'WindowEdge',#32)) then
    ExStyle := ExStyle or WS_EX_WINDOWEDGE;
  if (IsTok(tmp,'ClientEdge',#32)) then
    ExStyle := ExStyle or WS_EX_CLIENTEDGE;
  if (IsTok(tmp,'StaticEdge',#32)) then
    ExStyle := ExStyle or WS_EX_STATICEDGE;
  if (IsTok(tmp,'DlgModal',#32)) then
    ExStyle := ExStyle or WS_EX_DLGMODALFRAME;
  if (IsTok(tmp,'Border',#32)) then
    Style := Style or WS_BORDER;
  if (IsTok(tmp,'DlgFrame',#32)) then
    Style := Style or WS_DLGFRAME;
  StatusBar.ProgressBar[Panel-1].Vertical := false;
  if (IsTok(tmp,'Vertical',#32)) then
  begin
    Style := Style or PBS_VERTICAL;
    StatusBar.ProgressBar[Panel-1].Vertical := true;
  end;
  if (IsTok(tmp,'Smooth',#32)) then
    Style := Style or PBS_SMOOTH;
  if (IsTok(tmp,'Marquee',#32)) then
    Style := Style or PBS_MARQUEE;
  StatusBar.ProgressBar[Panel-1].Track := false;
  StatusBar.ProgressBar[Panel-1].HandCurs := false;
  if (IsTok(tmp,'Track',#32)) then
  begin
    Style := Style and not PBS_MARQUEE;
    StatusBar.ProgressBar[Panel-1].Track := true;
  end;
  if (IsTok(tmp,'HandCurs',#32)) then
    StatusBar.ProgressBar[Panel-1].HandCurs := true;
  StatusBar.ProgressBar[Panel-1].Handle := CreateWindowEx(ExStyle,PROGRESS_CLASS,nil,Style,0,0,0,0,StatusBar.Handle,Panel,0,nil);
  if (IsTok(tmp,'NoXPTheme',#32)) then
    SetWTheme(StatusBar.ProgressBar[Panel-1].Handle,false);
  if (not IsWindow(StatusBar.ProgressBar[Panel-1].Handle)) then
  begin
    lstrcpy(data,'ERROR: CAN''T CREATE THE PROGRESSBAR');
    exit;
  end;
  StatusBar.ProgressBar[Panel-1].MarqueeMs := 100;
  StatusBar.ProgressBar[Panel-1].PProc := Pointer(SetWindowLong(StatusBar.ProgressBar[Panel-1].Handle,GWL_WNDPROC,Longint(@ProgressBarWProc)));
  SendMessage(StatusBar.Handle,WM_SIZE,0,0);
end;

//<#panel>
function RemProgressBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 1) then
  begin
    lstrcpy(data,'ERROR: PROGRESSBAR NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (StatusBar.ProgressBar[Panel-1].PProc <> nil) then
    SetWindowLong(StatusBar.ProgressBar[Panel-1].Handle,GWL_WNDPROC,Longint(StatusBar.ProgressBar[Panel-1].PProc));
  DestroyWindow(StatusBar.ProgressBar[Panel-1].Handle);
  StatusBar.ProgressBar[Panel-1].Handle := 0;
  StatusBar.ProgressBar[Panel-1].PProc := nil;
  StatusBar.ProgressBar[Panel-1].MarqueeMs := 100;
  StatusBar.ProgressBar[Panel-1].Track := false;
  StatusBar.ProgressBar[Panel-1].HandCurs := false;
  StatusBar.ProgressBar[Panel-1].Vertical := false;
end;

//<#panel> [#pos] [<#min> <#max>]
function PBSetPos(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,Pos,Min,Max,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 1) then
  begin
    lstrcpy(data,'ERROR: PROGRESSBAR NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  val(PopTok(tmp,#32),Pos,E);
  if (E = 0) then
    SendMessage(StatusBar.ProgressBar[Panel-1].Handle,PBM_SETPOS,Pos,0);
  val(PopTok(tmp,#32),Min,E);
  if (E = 0) then
  begin
    val(PopTok(tmp,#32),Max,E);
    if (E = 0) then
      SendMessage(StatusBar.ProgressBar[Panel-1].Handle,PBM_SETRANGE32,Min,Max);
  end;
end;


//<#panel> <start | stop> [#delay]
function PBSetMarquee(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,State: String;
  Panel,E: Integer;
  Delay: Longint;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 1) then
  begin
    lstrcpy(data,'ERROR: PROGRESSBAR NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  State := PopTok(tmp,#32);
  if (State = 'START') then
  begin
    val(PopTok(tmp,#32),Delay,E);
    if (E = 0) then
      StatusBar.ProgressBar[Panel-1].MarqueeMs := Delay;
    SendMessage(StatusBar.ProgressBar[Panel-1].Handle,PBM_SETMARQUEE,1,StatusBar.ProgressBar[Panel-1].MarqueeMs);
  end
  else if (State = 'STOP') then
  begin
    SendMessage(StatusBar.ProgressBar[Panel-1].Handle,PBM_SETMARQUEE,0,0);
  end
  else
    lstrcpy(data,'ERROR: INVALID PARAMETER');
end;

//<#panel> [#rgb bar | default] [#rgb background | default]
function PBSetColors(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,Color: String;
  E,Panel: Integer;
  nRGB: Cardinal;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 1) then
  begin
    lstrcpy(data,'ERROR: PROGRESSBAR NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  nRGB := CLR_DEFAULT;
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    SendMessage(StatusBar.ProgressBar[Panel-1].Handle,PBM_SETBARCOLOR,0,nRGB)
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
      SendMessage(StatusBar.ProgressBar[Panel-1].Handle,PBM_SETBARCOLOR,0,nRGB);
  end;
  nRGB := CLR_DEFAULT;
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    SendMessage(StatusBar.ProgressBar[Panel-1].Handle,PBM_SETBKCOLOR,0,nRGB)
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
      SendMessage(StatusBar.ProgressBar[Panel-1].Handle,PBM_SETBKCOLOR,0,nRGB);
  end;
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////


//<#panel> [styles]
function AddTrackBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Style,ExStyle: Longint;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 0) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR PANEL IS ALREADY IN USE');
    exit;
  end;
  Style := WS_CHILD or WS_VISIBLE or TBS_HORZ or TBS_FIXEDLENGTH;
  ExStyle := 0;
  if (IsTok(tmp,'WindowEdge',#32)) then
    ExStyle := ExStyle or WS_EX_WINDOWEDGE;
  if (IsTok(tmp,'ClientEdge',#32)) then
    ExStyle := ExStyle or WS_EX_CLIENTEDGE;
  if (IsTok(tmp,'StaticEdge',#32)) then
    ExStyle := ExStyle or WS_EX_STATICEDGE;
  if (IsTok(tmp,'DlgModal',#32)) then
    ExStyle := ExStyle or WS_EX_DLGMODALFRAME;
  if (IsTok(tmp,'Border',#32)) then
    Style := Style or WS_BORDER;
  if (IsTok(tmp,'DlgFrame',#32)) then
    Style := Style or WS_DLGFRAME;
  if (IsTok(tmp,'Vertical',#32)) then
    Style := Style and not TBS_HORZ or TBS_VERT;
  if (IsTok(tmp,'AutoTicks',#32)) then
    Style := Style or TBS_AUTOTICKS;
  if (IsTok(tmp,'Both',#32)) then
    Style := Style or TBS_BOTH;
  if (IsTok(tmp,'NoTicks',#32)) then
    Style := Style or TBS_NOTICKS;
  if (IsTok(tmp,'SelRange',#32)) then
    Style := Style or TBS_ENABLESELRANGE;
  if (IsTok(tmp,'ToolTips',#32)) then
    Style := Style or TBS_TOOLTIPS;
  if (IsTok(tmp,'NoThumb',#32)) then
    Style := Style or TBS_NOTHUMB;
  if (IsTok(tmp,'NWTicks',#32)) then
    Style := Style or TBS_LEFT or TBS_TOP;
  StatusBar.TrackBar[Panel-1].Handle := CreateWindowEx(ExStyle,TRACKBAR_CLASS,nil,Style,0,0,0,0,StatusBar.Handle,Panel,0,nil);
  if (IsTok(tmp,'NoXPTheme',#32)) then
    SetWTheme(StatusBar.TrackBar[Panel-1].Handle,false);
  if (not IsWindow(StatusBar.TrackBar[Panel-1].Handle)) then
  begin
    lstrcpy(data,'ERROR: CAN''T CREATE THE TRACKBAR');
    exit;
  end;
  SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETRANGE,1,MakeLParam(0,100));
  SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETPOS,1,0);
  SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETLINESIZE,0,5);
  SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETPAGESIZE,0,10);
  SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETSELSTART,1,0);
  SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETSELEND,1,0);
  SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETTHUMBLENGTH,12,0);
  SendMessage(StatusBar.Handle,WM_SIZE,0,0);
end;

//<#panel>
function RemTrackBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 2) then
  begin
    lstrcpy(data,'ERROR: TRACKBAR NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  DestroyWindow(StatusBar.TrackBar[Panel-1].Handle);
  StatusBar.TrackBar[Panel-1].Handle := 0;
end;

//<#panel> [pos] [min] [max] [line] [page] [startsel] [endsel] [thumb]
function TBSetPos(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,Pos,Min,Max,Line,Page,StartSel,EndSel,Thumb,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 2) then
  begin
    lstrcpy(data,'ERROR: TRACKBAR NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  val(PopTok(tmp,#32),Pos,E);
  if (E = 0) then
    SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETPOS,1,Pos);
  val(PopTok(tmp,#32),Min,E);
  if (E = 0) then
    SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETRANGEMIN,1,Min);
  val(PopTok(tmp,#32),Max,E);
  if (E = 0) then
    SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETRANGEMAX,1,Max);
  val(PopTok(tmp,#32),Line,E);
  if (E = 0) then
    SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETLINESIZE,0,Line);
  val(PopTok(tmp,#32),Page,E);
  if (E = 0) then
    SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETPAGESIZE,0,Page);
  val(PopTok(tmp,#32),StartSel,E);
  if (E = 0) then
    SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETSELSTART,1,StartSel);
  val(PopTok(tmp,#32),EndSel,E);
  if (E = 0) then
    SendMessage(StatusBar.TrackBar[Panel-1].Handle, TBM_SETSELEND,1,EndSel);
  val(PopTok(tmp,#32),Thumb,E);
  if (E = 0) then
    SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETTHUMBLENGTH,Thumb,0);
end;


//<#panel> <disable | enable>
function TBSetState(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 2) then
  begin
    lstrcpy(data,'ERROR: TRACKBAR NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  tmp := PopTok(tmp,#32);
  if (tmp = 'ENABLE') then
    EnableWindow(StatusBar.TrackBar[Panel-1].Handle,true)
  else if (tmp = 'DISABLE') then
    EnableWindow(StatusBar.TrackBar[Panel-1].Handle,false)
  else
    lstrcpy(data,'ERROR: INVALID PARAMETER');
end;

//<#panel> <tick> [<tick> ...]
function TBSetFreq(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,n,t,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 2) then
  begin
    lstrcpy(data,'ERROR: TRACKBAR NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_CLEARTICS,0,0);
  for n := 1 to NumTok(tmp,#32) do
  begin
    val(PopTok(tmp,#32),t,E);
    if (E > 0) then
    begin
      lstrcpy(data,'ERROR: INVALID TICK MARK');
      exit;
    end;
    if ((GetWindowLong(StatusBar.TrackBar[Panel-1].Handle,GWL_STYLE) and TBS_AUTOTICKS) > 0) then
      SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETTICFREQ,t,0)
    else
      SendMessage(StatusBar.TrackBar[Panel-1].Handle,TBM_SETTIC,0,t);
  end;
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////

//<#panel> <@window name> [styles]
function AddWindow(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,Window: String;
  Handle: hWnd;
  Panel,Style,ExStyle,E: Integer;
  ClassName: array [0..15] of Char;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 0) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR PANEL IS ALREADY IN USE');
    exit;
  end;
  Window := PopTok(tmp,#32);
  Handle := GetHwnd(Window);
  if (not IsWindow(Handle)) then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW');
    exit;
  end;
  GetClassName(Handle,ClassName,15);
  if (ClassName <> 'mIRC_Custom') then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW');
    exit;
  end;
  if (IsPanelUsedStatusBar(GetPanelFromCtrlHwnd(Handle)) = 3) then
  begin
    lstrcpy(data,'ERROR: WINDOW ALREADY DOCKED');
    exit;
  end;
  Style := GetWindowLong(Handle,GWL_STYLE) and not (WS_POPUP or WS_CAPTION or WS_BORDER or WS_DLGFRAME or WS_SIZEBOX) or WS_CHILD or WS_VISIBLE;
  ExStyle := GetWindowLong(Handle,GWL_EXSTYLE) and not (WS_EX_DLGMODALFRAME or WS_EX_WINDOWEDGE or WS_EX_CLIENTEDGE or WS_EX_STATICEDGE);
  if (IsTok(tmp,'WindowEdge',#32)) then
    ExStyle := ExStyle or WS_EX_WINDOWEDGE;
  if (IsTok(tmp,'ClientEdge',#32)) then
    ExStyle := ExStyle or WS_EX_CLIENTEDGE;
  if (IsTok(tmp,'StaticEdge',#32)) then
    ExStyle := ExStyle or WS_EX_STATICEDGE;
  if (IsTok(tmp,'DlgModal',#32)) then
    ExStyle := ExStyle or WS_EX_DLGMODALFRAME;
  if (IsTok(tmp,'Border',#32)) then
    Style := Style or WS_BORDER;
  if (IsTok(tmp,'DlgFrame',#32)) then
    Style := Style or WS_DLGFRAME;
  SetWindowLong(Handle,GWL_STYLE,Style);
  SetWindowLong(Handle,GWL_EXSTYLE,ExStyle);
  if (IsTok(tmp,'NoXPTheme',#32)) then
  begin
    SetWTheme(Handle,false);
    EnumSetWTheme(Handle,0);
  end;
  SetParent(Handle,StatusBar.Handle);
  SetFocus(mIRCHandle);
  StatusBar.Window[Panel-1].Name := Window;
  StatusBar.Window[Panel-1].Handle := Handle;
  StatusBar.Window[Panel-1].PProc := Pointer(SetWindowLong(StatusBar.Window[Panel-1].Handle,GWL_WNDPROC,Longint(@WindowWProc)));
  SendMessage(StatusBar.Handle,WM_SIZE,0,0);
end;

//<#panel>
function RemWindow(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 3) then
  begin
    lstrcpy(data,'ERROR: WINDOW NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (StatusBar.Window[Panel-1].PProc <> nil) then
    SetWindowLong(StatusBar.Window[Panel-1].Handle,GWL_WNDPROC,Longint(StatusBar.Window[Panel-1].PProc));
  SendData('window -c '+StatusBar.Window[Panel-1].Name);
  StatusBar.Window[Panel-1].Name := '';
  StatusBar.Window[Panel-1].Handle := 0;
  StatusBar.Window[Panel-1].PProc := nil;
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////

//<#panel> [styles]
function AddButton(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Style,ExStyle: Longint;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 0) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR PANEL IS ALREADY IN USE');
    exit;
  end;
  Style := WS_CHILD or WS_VISIBLE or BS_VCENTER or BS_LEFT or BS_TEXT or BS_OWNERDRAW;
  ExStyle := 0;
  if (IsTok(tmp,'WindowEdge',#32)) then
    ExStyle := ExStyle or WS_EX_WINDOWEDGE;
  if (IsTok(tmp,'ClientEdge',#32)) then
    ExStyle := ExStyle or WS_EX_CLIENTEDGE;
  if (IsTok(tmp,'StaticEdge',#32)) then
    ExStyle := ExStyle or WS_EX_STATICEDGE;
  if (IsTok(tmp,'DlgModal',#32)) then
    ExStyle := ExStyle or WS_EX_DLGMODALFRAME;
  if (IsTok(tmp,'Border',#32)) then
    Style := Style or WS_BORDER;
  if (IsTok(tmp,'DlgFrame',#32)) then
    Style := Style or WS_DLGFRAME;
  if (IsTok(tmp,'Check',#32)) then
    Style := Style and not BS_OWNERDRAW or BS_AUTOCHECKBOX;
  if (IsTok(tmp,'Radio',#32)) then
    Style := Style and not (BS_OWNERDRAW or BS_AUTOCHECKBOX) or BS_AUTORADIOBUTTON;
  if (IsTok(tmp,'PushLike',#32)) then
    Style := Style or BS_PUSHLIKE;
  StatusBar.Button[Panel-1].pos := 0;
  if (IsTok(tmp,'Right',#32)) then
  begin
    Style := Style and not BS_LEFT or BS_RIGHT;
    StatusBar.Button[Panel-1].pos := 1;
  end;
  if (IsTok(tmp,'Center',#32)) then
  begin
    Style := Style and not (BS_LEFT or BS_RIGHT) or BS_CENTER;
    StatusBar.Button[Panel-1].pos := 2;
  end;
  if (IsTok(tmp,'Flat',#32)) then
    Style := Style or BS_FLAT;
    StatusBar.Button[Panel-1].bitmap := false;
  if (IsTok(tmp,'Bitmap',#32)) then
    StatusBar.Button[Panel-1].bitmap := true;
  StatusBar.Button[Panel-1].Handle := CreateWindowEx(ExStyle,'Button',nil,Style,0,0,0,0,StatusBar.Handle,Panel,0,nil);
  if (IsTok(tmp,'NoXPTheme',#32)) then
    SetWTheme(StatusBar.Button[Panel-1].Handle,false);
  if (not IsWindow(StatusBar.Button[Panel-1].Handle)) then
  begin
    lstrcpy(data,'ERROR: CAN''T CREATE THE BUTTON');
    exit;
  end;
  StatusBar.Button[Panel-1].PProc := Pointer(SetWindowLong(StatusBar.Button[Panel-1].Handle,GWL_WNDPROC,Longint(@ButtonWProc)));
  SendMessage(StatusBar.Button[Panel-1].Handle,WM_SETFONT,SendMessage(StatusBar.Handle,WM_GETFONT,0,0),1);
  SendMessage(StatusBar.Handle,WM_SIZE,0,0);
end;

//<#panel>
function RemButton(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (StatusBar.Button[Panel-1].PProc <> nil) then
    SetWindowLong(StatusBar.Button[Panel-1].Handle,GWL_WNDPROC,Longint(StatusBar.Button[Panel-1].PProc));
  DestroyWindow(StatusBar.Button[Panel-1].Handle);
  StatusBar.Button[Panel-1].Handle := 0;
  StatusBar.Button[Panel-1].PProc := nil;
  StatusBar.Button[Panel-1].Handle := 0;
  StatusBar.Button[Panel-1].PProc := nil;
  StatusBar.Button[Panel-1].pos := 0;
  StatusBar.Button[Panel-1].tme := false;
  StatusBar.Button[Panel-1].hover := false;
  StatusBar.Button[Panel-1].bitmap := false;
  StatusBar.Button[Panel-1].traspbmp := 0;
  DeleteObject(StatusBar.Button[Panel-1].normbmp);
  DeleteObject(StatusBar.Button[Panel-1].hoverbmp);
  DeleteObject(StatusBar.Button[Panel-1].pressbmp);
  DeleteObject(StatusBar.Button[Panel-1].graybmp);
  StatusBar.Button[Panel-1].normicon := 0;
  StatusBar.Button[Panel-1].hovericon := 0;
  StatusBar.Button[Panel-1].bVertical := false;  
  StatusBar.Button[Panel-1].Facegrad1 := 0;
  StatusBar.Button[Panel-1].bFacegrad1 := false;
  StatusBar.Button[Panel-1].Facegrad2 := 0;
  StatusBar.Button[Panel-1].bFacegrad2 := false;
  StatusBar.Button[Panel-1].Text := 0;
  StatusBar.Button[Panel-1].bText := false;
  StatusBar.Button[Panel-1].Graytext := 0;
  StatusBar.Button[Panel-1].bGraytext := false;
  StatusBar.Button[Panel-1].Light3d := 0;
  StatusBar.Button[Panel-1].bLight3d := false;
  StatusBar.Button[Panel-1].Darkshadow := 0;
  StatusBar.Button[Panel-1].bDarkshadow := false;
  StatusBar.Button[Panel-1].Highlight := 0;
  StatusBar.Button[Panel-1].bHighlight := false;
  StatusBar.Button[Panel-1].Shadow := 0;
  StatusBar.Button[Panel-1].bShadow := false;
  SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_DELTOOL,0,lParam(@StatusBar.Button[Panel-1].TipInfo));
  DestroyWindow(StatusBar.Button[Panel-1].TipHandle);
  StatusBar.Button[Panel-1].TipHandle := 0;
  StatusBar.Button[Panel-1].TipText := '';
  StatusBar.Button[Panel-1].bTipTrack := false;
end;

//<#panel> <disable | enable | check | uncheck>
function BSetState(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  tmp := PopTok(tmp,#32);
  if (tmp = 'ENABLE') then
    EnableWindow(StatusBar.Button[Panel-1].Handle,true)
  else if (tmp = 'DISABLE') then
    EnableWindow(StatusBar.Button[Panel-1].Handle,false)
  else if (tmp = 'CHECK') then
    SendMessage(StatusBar.Button[Panel-1].Handle,BM_SETCHECK,BST_CHECKED,0)
  else if (tmp = 'UNCHECK') then
    SendMessage(StatusBar.Button[Panel-1].Handle,BM_SETCHECK,BST_UNCHECKED,0)
  else
    lstrcpy(data,'ERROR: INVALID PARAMETER');
end;

//<#panel> [highlight border] [darkshadow border] [3dlight border] [shadow border] [face] [text] [gray text]
function BSetColors(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,Color: String;
  Panel,nRGB,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  //GRADIENT MODE
  Color := PopTok(tmp,#32);
  if (Color = 'HORIZONTAL') then
    StatusBar.Button[Panel-1].bVertical := false
  else if (Color = 'VERTICAL') then
    StatusBar.Button[Panel-1].bVertical := true;
  //GRADIENT FACE 1
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    StatusBar.Button[Panel-1].bFacegrad1 := false
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
    begin
      StatusBar.Button[Panel-1].bFacegrad1 := true;
      StatusBar.Button[Panel-1].Facegrad1 := nRGB;
    end;
  end;
  //GRADIENT FACE 2
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    StatusBar.Button[Panel-1].bFacegrad2 := false
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
    begin
      StatusBar.Button[Panel-1].bFacegrad2 := true;
      StatusBar.Button[Panel-1].Facegrad2 := nRGB;
    end;
  end;
  //HIGHLIGHT
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    StatusBar.Button[Panel-1].bHighlight := false
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
    begin
      StatusBar.Button[Panel-1].bHighlight := true;
      StatusBar.Button[Panel-1].Highlight := nRGB;
    end;
  end;
  //DARKSHADOW
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    StatusBar.Button[Panel-1].bDarkshadow := false
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
    begin
      StatusBar.Button[Panel-1].bDarkshadow := true;
      StatusBar.Button[Panel-1].Darkshadow := nRGB;
    end;
  end;
  //3DLIGHT
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    StatusBar.Button[Panel-1].bLight3d := false
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
    begin
      StatusBar.Button[Panel-1].bLight3d := true;
      StatusBar.Button[Panel-1].Light3d := nRGB;
    end;
  end;
  //SHADOW
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    StatusBar.Button[Panel-1].bShadow := false
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
    begin
      StatusBar.Button[Panel-1].bShadow := true;
      StatusBar.Button[Panel-1].Shadow := nRGB;
    end;
  end;
  //TEXT
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    StatusBar.Button[Panel-1].bText := false
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
    begin
      StatusBar.Button[Panel-1].bText := true;
      StatusBar.Button[Panel-1].Text := nRGB;
    end;
  end;
  //TEXT GRAY
  Color := PopTok(tmp,#32);
  if (Color = 'DEFAULT') then
    StatusBar.Button[Panel-1].bGraytext := false
  else
  begin
    val(Color,nRGB,E);
    if (E = 0) then
    begin
      StatusBar.Button[Panel-1].bGraytext := true;
      StatusBar.Button[Panel-1].Graytext := nRGB;
    end;
  end;
  InvalidateRect(StatusBar.Button[Panel-1].Handle,nil,true);
end;

//<panel> <trasparent rgb> <file normal bitmap> $chr(9) <file hover bitmap> $chr(9) <file pressed bitmap> $chr(9) <file gray bitmap>
function BLoadBitmap(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,nRGB,E: Integer;
  normbmp,hoverbmp,pressbmp,graybmp: PChar;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (not StatusBar.Button[Panel-1].bitmap) then
  begin
    lstrcpy(data,'ERROR: THIS BUTTON DON''T USE BITMAP');
    exit;
  end;
  val(PopTok(tmp,#32),nRGB,E);
  if (E > 0) then
  begin
    lstrcpy(data,'ERROR: INVALID RGB VALUE');
    exit;
  end;
  normbmp := pChar(PopTok(tmp,#9));
  hoverbmp := pChar(PopTok(tmp,#9));
  pressbmp := pChar(PopTok(tmp,#9));
  graybmp := pChar(PopTok(tmp,#9));
  StatusBar.Button[Panel-1].traspbmp := nRGB;
  DeleteObject(StatusBar.Button[Panel-1].normbmp);
  DeleteObject(StatusBar.Button[Panel-1].hoverbmp);
  DeleteObject(StatusBar.Button[Panel-1].pressbmp);
  DeleteObject(StatusBar.Button[Panel-1].graybmp);
  StatusBar.Button[Panel-1].normbmp := LoadImage(0,normbmp,IMAGE_BITMAP,0,0,LR_LOADFROMFILE or LR_DEFAULTSIZE);
  StatusBar.Button[Panel-1].hoverbmp := LoadImage(0,hoverbmp,IMAGE_BITMAP,0,0,LR_LOADFROMFILE or LR_DEFAULTSIZE);
  StatusBar.Button[Panel-1].pressbmp := LoadImage(0,pressbmp,IMAGE_BITMAP,0,0,LR_LOADFROMFILE or LR_DEFAULTSIZE);
  StatusBar.Button[Panel-1].graybmp := LoadImage(0,graybmp,IMAGE_BITMAP,0,0,LR_LOADFROMFILE or LR_DEFAULTSIZE);
  InvalidateRect(StatusBar.Button[Panel-1].Handle,nil,true);
end;

//<panel> [icon normal] [icon hover] [text]
function BSetText(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,tmp2: String;
  Icon,IconHover,Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  tmp2 := tmp;
  val(PopTok(tmp,#32),Icon,E);
  if (E = 0) then
    StatusBar.Button[Panel-1].normicon := Icon
  else
    tmp := tmp2;
  tmp2 := tmp;
  val(PopTok(tmp,#32),IconHover,E);
  if (E = 0) then
    StatusBar.Button[Panel-1].hovericon := IconHover
  else
    tmp := tmp2;
  SendMessage(StatusBar.Button[Panel-1].Handle,WM_SETTEXT,0,lParam(pChar(tmp)));
end;

//<panel> [-aisu] <#size> <#weight> <font name>
function BSetFont(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,tmp2,Styles: String;
  E,Panel: Integer;
  Font: tagLOGFONT;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  tmp2 := tmp;
  Styles := PopTok(tmp,#32);
  Font.lfQuality := NONANTIALIASED_QUALITY;
  Font.lfItalic := 0;
  Font.lfStrikeOut := 0;
  Font.lfUnderline := 0;
  if (CharIsIn(Styles,'-')) then
  begin
    if (CharIsIn(Styles,'A')) then
      Font.lfQuality := ANTIALIASED_QUALITY;
    if (CharIsIn(Styles,'I')) then
      Font.lfItalic := 1;
    if (CharIsIn(Styles,'S')) then
      Font.lfStrikeOut := 1;
    if (CharIsIn(Styles,'U')) then
      Font.lfUnderline := 1;
  end
  else
    tmp := tmp2;
  val(PopTok(tmp,#32),Font.lfHeight,E);
  if (E > 0) then
  begin
   lstrcpy(data,'ERROR: INVALID SIZE');
   exit;
  end;
  val(PopTok(tmp,#32),Font.lfWeight,E);
  if ((E > 0) or ((Font.lfWeight < 0) and (Font.lfWeight > 700))) then
  begin
   lstrcpy(data,'ERROR: INVALID WEIGHT');
   exit;
  end;
  Font.lfWidth := 0;
  Font.lfEscapement := GM_COMPATIBLE;
  Font.lfOrientation := 0;
  Font.lfCharSet := DEFAULT_CHARSET;
  Font.lfOutPrecision := OUT_CHARACTER_PRECIS;
  Font.lfClipPrecision := CLIP_CHARACTER_PRECIS;
  Font.lfPitchAndFamily := DEFAULT_PITCH;
  lstrcpy(Font.lfFaceName,PChar(tmp));
  SendMessage(StatusBar.Button[Panel-1].Handle,WM_SETFONT,CreateFontIndirect(Font),1);
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////

//<#panel> [styles]
function BAddToolTip(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Style: Longint;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: TOOLTIP ALREADY FOUND ON THIS BUTTON');
    exit;
  end;
  Style := TTS_NOPREFIX;
  if (IsTok(tmp,'Balloon',#32)) then
    Style := Style or TTS_BALLOON;
  StatusBar.Button[Panel-1].bTipTrack := false;
  if (IsTok(tmp,'Track',#32)) then
    StatusBar.Button[Panel-1].bTipTrack := true;
  StatusBar.Button[Panel-1].TipHandle := CreateWindowEx(WS_EX_TOPMOST,TOOLTIPS_CLASS,nil,Style,0,0,0,0,0,0,0,nil);
  if (not IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: CAN''T CREATE THE TOOLTIP');
    exit;
  end;
  StatusBar.Button[Panel-1].TipInfo.cbSize := SizeOf(TOOLINFO);
  StatusBar.Button[Panel-1].TipInfo.uFlags := TTF_SUBCLASS or TTF_IDISHWND;
  StatusBar.Button[Panel-1].TipInfo.uId := StatusBar.Button[Panel-1].Handle;
  StatusBar.Button[Panel-1].TipInfo.hInst := Panel;
  StatusBar.Button[Panel-1].TipInfo.hwnd := StatusBar.Button[Panel-1].Handle;
  StatusBar.Button[Panel-1].TipInfo.lpszText := '';
    SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_ADDTOOL,0,lParam(@StatusBar.Button[Panel-1].TipInfo));
  if (not StatusBar.Button[Panel-1].bTipTrack) then
    SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_ACTIVATE,1,0);
  SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_SETMAXTIPWIDTH,0,250);
end;

//<#panel>
function BRemToolTip(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (not IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: TOOLTIP NOT FOUND ON THIS BUTTON');
    exit;
  end;
  SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_DELTOOL,0,lParam(@StatusBar.Button[Panel-1].TipInfo));
  DestroyWindow(StatusBar.Button[Panel-1].TipHandle);
  StatusBar.Button[Panel-1].TipHandle := 0;
  StatusBar.Button[Panel-1].bTipTrack := false;
  StatusBar.Button[Panel-1].TipText := '';
end;

//<#panel> [text]
function BTTSetText(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (not IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: TOOLTIP NOT FOUND ON THIS BUTTON');
    exit;
  end;
  StatusBar.Button[Panel-1].TipInfo.lpszText := pChar(tmp);
  StatusBar.Button[Panel-1].TipText := tmp;
  SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_UPDATETIPTEXT,0,lParam(@StatusBar.Button[Panel-1].TipInfo));
end;

//<#panel> [#icon] [title]
function BTTSetTitle(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,tmp2: String;
  Panel,Icon,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (not IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: TOOLTIP NOT FOUND ON THIS BUTTON');
    exit;
  end;
  tmp2 := tmp;
  val(PopTok(tmp,#32),Icon,E);
  if (E > 0) or (not Icon in [0..3]) then
  begin
    Icon := 0;
    tmp := tmp2;
  end;
  SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_SETTITLE,Icon,lParam(pChar(tmp)));
end;

//<#panel> <#size>
function BTTSetMaxWidth(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
  Panel,Size,E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (not IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: TOOLTIP NOT FOUND ON THIS BUTTON');
    exit;
  end;
  val(PopTok(tmp,#32),Size,E);
  if (E > 0) then
  begin
    lstrcpy(data,'ERROR: INVALID SIZE');
    exit;
  end;
  SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_SETMAXTIPWIDTH,0,Size);
end;

//<#panel> [text] [background]
function BTTSetColors(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,Color: String;
  Panel,E: Integer;
  nRGB: Cardinal;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (not IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: TOOLTIP NOT FOUND ON THIS BUTTON');
    exit;
  end;
  //TEXT
  Color := PopTok(tmp,#32);
  val(Color,nRGB,E);
  if (E = 0) then
    SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_SETTIPTEXTCOLOR,nRGB,0);
  //BACKGROUND
  Color := PopTok(tmp,#32);
  val(Color,nRGB,E);
  if (E = 0) then
    SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_SETTIPBKCOLOR,nRGB,0);
end;

//<panel> [-aisu] <#size> <#weight> <font name>
function BTTSetFont(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,tmp2,Styles: String;
  E,Panel: Integer;
  Font: tagLOGFONT;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (not IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: TOOLTIP NOT FOUND ON THIS BUTTON');
    exit;
  end;
  tmp2 := tmp;
  Styles := PopTok(tmp,#32);
  Font.lfQuality := NONANTIALIASED_QUALITY;
  Font.lfItalic := 0;
  Font.lfStrikeOut := 0;
  Font.lfUnderline := 0;
  if (CharIsIn(Styles,'-')) then
  begin
    if (CharIsIn(Styles,'A')) then
      Font.lfQuality := ANTIALIASED_QUALITY;
    if (CharIsIn(Styles,'I')) then
      Font.lfItalic := 1;
    if (CharIsIn(Styles,'S')) then
      Font.lfStrikeOut := 1;
    if (CharIsIn(Styles,'U')) then
      Font.lfUnderline := 1;
  end
  else
    tmp := tmp2;
  val(PopTok(tmp,#32),Font.lfHeight,E);
  if (E > 0) then
  begin
   lstrcpy(data,'ERROR: INVALID SIZE');
   exit;
  end;
  val(PopTok(tmp,#32),Font.lfWeight,E);
  if ((E > 0) or ((Font.lfWeight < 0) and (Font.lfWeight > 700))) then
  begin
   lstrcpy(data,'ERROR: INVALID WEIGHT');
   exit;
  end;
  Font.lfWidth := 0;
  Font.lfEscapement := GM_COMPATIBLE;
  Font.lfOrientation := 0;
  Font.lfCharSet := DEFAULT_CHARSET;
  Font.lfOutPrecision := OUT_CHARACTER_PRECIS;
  Font.lfClipPrecision := CLIP_CHARACTER_PRECIS;
  Font.lfPitchAndFamily := DEFAULT_PITCH;
  lstrcpy(Font.lfFaceName,PChar(tmp));
  SendMessage(StatusBar.Button[Panel-1].TipHandle,WM_SETFONT,CreateFontIndirect(Font),1);
end;

//<#panel> <delay type> <#delay>
function BTTSetDelay(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,Delay: String;
  Panel,E: Integer;
  ms: Longint;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  if (not IsWindow(StatusBar.Handle)) then
  begin
    lstrcpy(data,'ERROR: STATUSBAR NOT IN USE');
    exit;
  end;
  val(PopTok(tmp,#32),Panel,E);
  if ((E > 0) or (not IsPanelStatusBar(Panel))) then
  begin
    lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
    exit;
  end;
  if (IsPanelUsedStatusBar(Panel) <> 4) then
  begin
    lstrcpy(data,'ERROR: BUTTON NOT FOUND IN THIS STATUSBAR PANEL');
    exit;
  end;
  if (not IsWindow(StatusBar.Button[Panel-1].TipHandle)) then
  begin
    lstrcpy(data,'ERROR: TOOLTIP NOT FOUND ON THIS BUTTON');
    exit;
  end;
  Delay := PopTok(tmp,#32);
  if (Delay = 'INITIAL') then
  begin
    val(PopTok(tmp,#32),ms,E);
    if (E > 0) then
    begin
      lstrcpy(data,'ERROR: INVALID DELAY VALUE');
      exit;
    end;
    SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_SETDELAYTIME,TTDT_INITIAL,MakeLong(ms,0));
  end
  else if (Delay = 'AUTOPOP') then
  begin
    val(PopTok(tmp,#32),ms,E);
    if (E > 0) then
    begin
      lstrcpy(data,'ERROR: INVALID DELAY VALUE');
      exit;
    end;
    SendMessage(StatusBar.Button[Panel-1].TipHandle,TTM_SETDELAYTIME,TTDT_AUTOPOP,MakeLong(ms,0));
  end
  else
  begin
    lstrcpy(data,'ERROR: INVALID DELAY TYPE');
    exit;
  end;
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////

function GetInfo(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,Info: String;
  SidePos,QueuePos,n,i,Size,E: Integer;
  r: TRect;
  Panels: array [0..255] of Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'ERROR: INVALID PARAMETER');
  Info := PopTok(tmp,#32);
  if (Info = 'ISMENUBARVISIBLE') then
  begin
    if (IsMenu(GetMenu(mIRCHandle))) then
      lstrcpy(data,'$true')
    else
      lstrcpy(data,'$false');
  end
  else if (Info = 'ISTOOLBARVISIBLE') then
  begin
    if (IsWindowVisible(mIRCHToolBar)) then
      lstrcpy(data,'$true')
    else
      lstrcpy(data,'$false');
  end
  else if (Info = 'ISSWITCHBARVISIBLE') then
  begin
    if (IsWindowVisible(mIRCHSwitchBar)) then
      lstrcpy(data,'$true')
    else
      lstrcpy(data,'$false');
  end
  else if (Info = 'ISSTATUSBARINUSE') then
  begin
    if (IsWindow(StatusBar.Handle)) then
      lstrcpy(data,'$true')
    else
      lstrcpy(data,'$false');
  end
  else if (Info = 'STATUSBARSIZE') then
  begin
    GetClientRect(StatusBar.Handle,r);
    lstrcpy(data,pChar(inttostr(r.Right)+' '+inttostr(r.Bottom)));
  end
  else if (Info = 'ICONLISTSIZE') then
  begin
    ImageList_GetIconSize(StatusBar.ImageList,Size,Size);
    if (Size = 32) then
      lstrcpy(data,'LARGE')
    else if (Size = 16) then
      lstrcpy(data,'SMALL')
    else
      lstrcpy(data,'ERROR: ICONLIST ISN''T CREATED');
  end
  else if (Info = 'STATUSBARPANELS') then
  begin
    n := SendMessage(StatusBar.Handle,SB_GETPARTS,0,0);
    SendMessage(StatusBar.Handle,SB_GETPARTS,n,lParam(@Panels));
    for i := 0 to n-1 do
      tmp := tmp+' '+inttostr(Panels[i]);
    lstrcpy(data,pChar(tmp));
  end
  else if (Info = 'PANELSIZE') then
  begin
    val(PopTok(tmp,#32),n,E);
    if (E > 0) or (not IsPanelStatusBar(n)) then
    begin
      lstrcpy(data,'ERROR: INVALID STATUSBAR PANEL');
      exit;
    end;
    SendMessage(StatusBar.Handle,SB_GETRECT,n-1,lParam(@r));
    lstrcpy(data,pChar(inttostr(r.Right-r.Left)+' '+inttostr(r.Bottom-r.Top)));
  end
  else if (Info = 'SWITCHBARPOSITION') then
  begin
    case SwitchBarPosition of
      0: lstrcpy(data,'BOTTOM');
      1: lstrcpy(data,'TOP');
      2: lstrcpy(data,'LEFT');
      3: lstrcpy(data,'RIGHT');
    end;
  end
  else if (Info = 'DOCKSNUMBER') then
  begin
    n := 0;
    for SidePos := 0 to 3 do
      for QueuePos := 0 to NUM_DOCK do
        if (IsWindow(Side[SidePos].Dock[QueuePos].Handle)) then
          inc(n);
    lstrcpy(data,pChar(inttostr(n)));
  end;
end;

//[text]
function SetmIRCTitleBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  Buffer: array [0..900] of Char;
  Len: Integer;
begin
  Result := 3;
  Len := Length(TitleBar)+1;
  TitleBar := data;
  lstrcpy(data,'OK');
  GetWindowText(mIRCHandle,@Buffer,900);
  lstrcpy(@buffer,pChar(':'+Copy(Buffer,Len,900)));
  SetWindowText(mIRCHandle,@Buffer);
end;

//<$window(windowname).hwnd> <[#id,]iconfilename>
function SetIcon(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,tmp2: String;
  Handle: hWnd;
  E,IconId: Integer;
  hIcon16,hIcon32: hIcon;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  val(PopTok(tmp,#32),Handle,E);
  if (E > 0) then
  begin
    lstrcpy(data,'ERROR: INVALID WINDOW HANDLE');
    exit;
  end;
  tmp2 := tmp;
  val(PopTok(tmp,#44),IconId,E);
  if (E > 0) then
  begin
    tmp := tmp2;
    IconId := 0;
  end;
  if (ExtractIconEx(pChar(tmp),IconId,hIcon32,hIcon16,1) > 0) then
  begin
    DestroyIcon(SendMessage(Handle,WM_SETICON,ICON_SMALL,hIcon16));
    DestroyIcon(SendMessage(Handle,WM_SETICON,ICON_BIG,hIcon32));
  end
  else
  begin
    DestroyIcon(hIcon16);
    DestroyIcon(hIcon32);
    lstrcpy(data,'ERROR: INVALID ICON');
  end;
end;

//<false | true>
function ShowMenuBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
begin
  Result := 3;
  tmp := trim(UpperCase(data));
  lstrcpy(data,'OK');
  if (tmp = 'TRUE') then
    SetMenu(mIRCHandle,mIRCHmenu)
  else if (tmp = 'FALSE') then
    SetMenu(mIRCHandle,0)
  else
    lstrcpy(data,'ERROR: INVALID PARAMETER');
end;

//<false | true>
function ShowToolBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
begin
  Result := 3;
  tmp := trim(UpperCase(data));
  lstrcpy(data,'OK');
  if (tmp = 'TRUE') then
    ShowWindow(mIRCHToolBar,SW_SHOW)
  else if (tmp = 'FALSE') then
    ShowWindow(mIRCHToolBar,SW_HIDE)
  else
  begin
    lstrcpy(data,'ERROR: INVALID PARAMETER');
    exit;
  end;
end;

//<false | true>
function ShowSwitchBar(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp: String;
begin
  Result := 3;
  tmp := trim(UpperCase(data));
  lstrcpy(data,'OK');
  if (tmp = 'TRUE') then
    ShowWindow(mIRCHSwitchBar,SW_SHOW)
  else if (tmp = 'FALSE') then
    ShowWindow(mIRCHSwitchBar,SW_HIDE)
  else
  begin
    lstrcpy(data,'ERROR: INVALID PARAMETER');
    exit;
  end;
end;

//<$dialog(dialogname).hwnd | $window(windowname).hwnd> <on | off> [#Id[,#Id,..]]
function SetWinTheme(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,Status: String;
  ClassName: array [0..15] of Char;
  Handle,ChildHandle: hWnd;
  nStatus,n,E,Id: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  val(PopTok(tmp,#32),Handle,E);
  if ((E > 0) or (not IsWindow(Handle))) then
  begin
    lstrcpy(data,'ERROR: INVALID HANDLE');
    exit;
  end;
  Status := PopTok(tmp,#32);
  if (Status = 'ON') then
    nStatus := 1
  else if (Status = 'OFF') then
    nStatus := 0
  else
  begin
    lstrcpy(data,'ERROR: INVALID STATUS PARAMETER');
    exit;
  end;
  GetClassName(Handle,ClassName,15);
  if (ClassName = '#32770') and (tmp <> '') then
  begin
    for n := 1 to NumTok(tmp,#44) do
    begin
      val(PopTok(tmp,#44),Id,E);
      if (E > 0) then
      begin
        lstrcpy(data,'ERROR: INVALID ID');
        exit;
      end;
      ChildHandle := GetDlgItem(Handle,Id+6000);
      if (not IsWindow(ChildHandle)) then
      begin
        lstrcpy(data,'ERROR: INVALID ID');
        exit;
      end;
      SetWTheme(ChildHandle,Boolean(nStatus));
      EnumChildWindows(ChildHandle,@EnumSetWTheme,nStatus);
    end;
  end
  else
  begin
    SetWTheme(Handle,Boolean(nStatus));
  end;
end;

//<$dialog(dialogname).hwnd | $window(windowname).hwnd> <alpha value | default>
function SetWinTransparency(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,Alpha: String;
  Handle: hWnd;
  E,nAlpha: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  val(PopTok(tmp,#32),Handle,E);
  if ((E > 0) or (not IsWindow(Handle))) then
  begin
    lstrcpy(data,'ERROR: INVALID HANDLE');
    exit;
  end;
  Alpha := PopTok(tmp,#32);
  if (Alpha = 'DEFAULT') then
    SetWindowLong(Handle,GWL_EXSTYLE,GetWindowLong(Handle,GWL_EXSTYLE) and not WS_EX_LAYERED)
  else
  begin
    val(Alpha,nAlpha,E);
    if ((E > 0) or (not nAlpha in [0..255]))  then
    begin
      lstrcpy(data,'ERROR: INVALID TRANSPARENCY VALUE');
      exit;
    end;
    SetWindowLong(Handle,GWL_EXSTYLE,GetWindowLong(Handle,GWL_EXSTYLE) or WS_EX_LAYERED);
    SetLayeredWindowAttributes(Handle,0,nAlpha,LWA_ALPHA);
  end;
end;

//<$window().hwnd | $dialog().hwnd> <true | false>
function EnableMinBox(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,State: String;
  Handle: hWnd;
  E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  val(PopTok(tmp,#32),Handle,E);
  if ((E > 0) or (not IsWindow(Handle))) then
  begin
    lstrcpy(data,'ERROR: INVALID HANDLE');
    exit;
  end;
  State := PopTok(tmp,#32);
  if (State = 'TRUE') then
    SetWindowLong(Handle,GWL_STYLE,GetWindowLong(Handle,GWL_STYLE) or WS_MINIMIZEBOX)
  else if (State = 'FALSE') then
    SetWindowLong(Handle,GWL_STYLE,GetWindowLong(Handle,GWL_STYLE) and not WS_MINIMIZEBOX)
  else
  begin
    lstrcpy(data,'ERROR: INVALID PARAMETER');
    exit;
  end;
  SetWindowPos(Handle,0,0,0,0,0,SWP_FRAMECHANGED or SWP_NOOWNERZORDER or SWP_NOACTIVATE or SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE);
end;

//<$window().hwnd | $dialog().hwnd> <true | false>
function EnableMaxBox(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,State: String;
  Handle: hWnd;
  E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  val(PopTok(tmp,#32),Handle,E);
  if ((E > 0) or (not IsWindow(Handle))) then
  begin
    lstrcpy(data,'ERROR: INVALID HANDLE');
    exit;
  end;
  State := PopTok(tmp,#32);
  if (State = 'TRUE') then
    SetWindowLong(Handle,GWL_STYLE,GetWindowLong(Handle,GWL_STYLE) or WS_MAXIMIZEBOX)
  else if (State = 'FALSE') then
    SetWindowLong(Handle,GWL_STYLE,GetWindowLong(Handle,GWL_STYLE) and not WS_MAXIMIZEBOX)
  else
  begin
    lstrcpy(data,'ERROR: INVALID PARAMETER');
    exit;
  end;
  SetWindowPos(Handle,0,0,0,0,0,SWP_FRAMECHANGED or SWP_NOOWNERZORDER or SWP_NOACTIVATE or SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE);
end;

//<$window().hwnd | $dialog().hwnd> <true | false>
function EnableCloseBox(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,State: String;
  Handle: hWnd;
  E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  val(PopTok(tmp,#32),Handle,E);
  if ((E > 0) or (not IsWindow(Handle))) then
  begin
    lstrcpy(data,'ERROR: INVALID HANDLE');
    exit;
  end;
  State := PopTok(tmp,#32);
  if (State = 'TRUE') then
    SetClassLong(Handle,GCL_STYLE,GetClassLong(Handle,GCL_STYLE) and not CS_NOCLOSE)
  else if (State = 'FALSE') then
    SetClassLong(Handle,GCL_STYLE,GetClassLong(Handle,GCL_STYLE) or CS_NOCLOSE)
  else
  begin
    lstrcpy(data,'ERROR: INVALID PARAMETER');
    exit;
  end;
  SetWindowPos(Handle,0,0,0,0,0,SWP_FRAMECHANGED or SWP_NOOWNERZORDER or SWP_NOACTIVATE or SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE);
end;

//<$window().hwnd | $dialog().hwnd> <true | false>
function EnableSizeBox(mWnd,aWnd: hWnd; data,parms: pChar; show,nopause: Bool): Integer; stdcall;
var
  tmp,State: String;
  Handle: hWnd;
  E: Integer;
begin
  Result := 3;
  tmp := data;
  lstrcpy(data,'OK');
  val(PopTok(tmp,#32),Handle,E);
  if ((E > 0) or (not IsWindow(Handle))) then
  begin
    lstrcpy(data,'ERROR: INVALID HANDLE');
    exit;
  end;
  State := PopTok(tmp,#32);
  if (State = 'TRUE') then
    SetWindowLong(Handle,GWL_STYLE,GetWindowLong(Handle,GWL_STYLE) or WS_MAXIMIZEBOX or WS_SIZEBOX)
  else if (State = 'FALSE') then
    SetWindowLong(Handle,GWL_STYLE,GetWindowLong(Handle,GWL_STYLE) and not (WS_MAXIMIZEBOX or WS_SIZEBOX))
  else
  begin
    lstrcpy(data,'ERROR: INVALID PARAMETER');
    exit;
  end;
  SetWindowPos(Handle,0,0,0,0,0,SWP_FRAMECHANGED or SWP_NOOWNERZORDER or SWP_NOACTIVATE or SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE);
end;


exports
  LoadDll,UnloadDll,InfoDll,
  GetInfo,
  SetIcon,SetmIRCTitleBar,SetWinTheme,SetWinTransparency,

  ShowMenuBar,ShowToolBar,ShowSwitchBar,

  EnableMinBox,EnableMaxBox,EnableCloseBox,EnableSizeBox,

  Dock,Undock,DockSize,DockSwitchBarInOut,

  AddStatusBar,RemStatusBar,
  SBSetPanels,SBSetHeight,SBSetData,
  SBCreateIconList,SBDestroyIconList,SBAddIcon,SBSetFont,SBSetBGColor,
  AddProgressBar,RemProgressBar,PBSetPos,PBSetMarquee,PBSetColors,
  AddTrackBar,RemTrackBar,TBSetPos,TBSetState,TBSetFreq,
  AddWindow,RemWindow,
  AddButton,RemButton,BSetState,BSetColors,BSetText,BLoadBitmap,BSetFont,
      BAddToolTip,BRemToolTip,BTTSetText,BTTSetTitle,BTTSetMaxWidth,BTTSetColors,BTTSetFont,BTTSetDelay;

begin
end.

